#include "StringParser.hpp"

COMMAND_TYPE g_command = NO_COMMAND;

StringParser::StringParser()
{
    m_module = "";
    m_command = "";
    m_operation = "";
    for (int i=0; i<7; i++)
    {
        m_parameter[i] = "";
        m_origParameter[i] = "";
    }
    m_parameter_count = 0;;
}



StringParser::~StringParser()
{

}



int
StringParser::getModule(string *module)
{
    *module = m_module;
    return 0;
}



int
StringParser::getCommand(string *command)
{
    *command = m_command;
    return 0;
}



int
StringParser::getOperation(string *operation)
{
    *operation = m_operation;
    return 0;
}



int
StringParser::getParameter(string *parameter, int index)
{
    *parameter = m_parameter[index];
    return 0;
}

int
StringParser::getOrigParameter(string *parameter, int index)
{
    *parameter = m_origParameter[index];
    return 0;
}




int
StringParser::getParameterNumber(int *nunber)
{
    *nunber = m_parameter_count;
    return 0;
}



int
StringParser::getCommandType(COMMAND_TYPE *command_type_id)
{
    *command_type_id = m_command_type;
    return 0;
}



int
StringParser::getOperationType(OPERATION_TYPE *operation_type_id)
{
    *operation_type_id = m_operation_type;
    return 0;
}



int
StringParser::initialParser(char **argv, int argc)
{
	int result = 0;
	
    //Calculate the number of parameters
    if (argc < 4)
    {
        m_parameter_count = 0;
    }
    else
    {
        m_parameter_count = argc - 4;
    }


    if ( m_parameter_count > PARAMETERS_NUMBER)
    {
    	  printf("The number of arguments greater than 7!!!\n");
        return 1;
    }


    if (argc > 1)
    {
        convertToLowcase(argv[1]);
        m_module = argv[1];
    }
    if (argc > 2)
    {
        convertToLowcase(argv[2]);
        m_command = argv[2];
        if (m_command == "test")
        {
            g_command = CMD_TEST;
        }
    }
    if (argc > 3)
    {
        convertToLowcase(argv[3]);
        m_operation = argv[3];
    }
    if (argc > 4)
    {
    	result = check_rearrange_argv(argv[4]);
    	m_origParameter[0] = argv[4];
        if (result != 1)
        {
            convertToLowcase(argv[4]);
        }
        m_parameter[0] = argv[4];
    }
    if (argc > 5)
    {
    	result = check_rearrange_argv(argv[5]);
    	m_origParameter[1] = argv[5];
        if (result != 1)
        {
            convertToLowcase(argv[5]);
        }
        m_parameter[1] = argv[5];
    }
    if (argc > 6)
    {
    	result = check_rearrange_argv(argv[6]);
    	m_origParameter[2] = argv[6];
        if (result != 1)
        {
            convertToLowcase(argv[6]);
        }
        m_parameter[2] = argv[6];
    }
    if (argc > 7)
    {
    	result = check_rearrange_argv(argv[7]);
    	m_origParameter[3] = argv[7];
        if (result != 1)
        {
            convertToLowcase(argv[7]);
        }
        m_parameter[3] = argv[7];
    }
    if (argc > 8)
    {
    	result = check_rearrange_argv(argv[8]);
    	m_origParameter[4] = argv[8];
        if (result != 1)
        {
            convertToLowcase(argv[8]);
        }
        m_parameter[4] = argv[8];
    }
    if (argc > 9)
    {
    	result = check_rearrange_argv(argv[9]);
    	m_origParameter[5] = argv[9];
        if (result != 1)
        {
            convertToLowcase(argv[9]);
        }
        m_parameter[5] = argv[9];
    }
    if (argc > 10)
    {
    	result = check_rearrange_argv(argv[10]);
    	m_origParameter[6] = argv[10];
        if (result != 1)
        {
            convertToLowcase(argv[10]);
        }
        m_parameter[6] = argv[10];
    }

    m_command_type = convertCommandStringToEnum(m_command);
    m_operation_type = convertOperationStringToEnum(m_operation);

    return 0;
}



int
StringParser::convertToLowcase(char *str)
{
    int i;
    
    for (i=0; str[i]; i++)
    {
        str[i] = tolower(str[i]);
    }

    return 0;
}



int
StringParser::convertStringToHex(string string_hex, int *value_hex)
{
    int hex,result;
    
    result = sscanf(string_hex.c_str(), "%x", &hex);
    //printf("String_hex_convert result: %d\n", result);
    
    if (result == 0)
    {
        *value_hex = 0;
        printf("Input value \"%s\" is not hexadecimal.\n", string_hex.c_str());
        return -1;
    }
    else
    {
        *value_hex = hex;
    }

    return 0;
}



int
StringParser::convertStringToHex(string string_hex, unsigned long long *value_hex)
{
    unsigned long long hex,result;

    result = sscanf(string_hex.c_str(), "%llx", &hex);
    //printf("String_hex_convert result: %d\n", result);

    if (result == 0)
    {
        *value_hex = 0;
        printf("Input value \"%s\" is not hexadecimal.\n", string_hex.c_str());
        return -1;
    }
    else
    {
        *value_hex = hex;
    }

    return 0;
}



int
StringParser::convertStringToDec(string string_hex, int *value_dec)
{
    int dec,result;

    result = sscanf(string_hex.c_str(), "%d", &dec);
    //printf("String_hex_convert result: %d\n", result);

    if (result == 0)
    {
        *value_dec = 0;
        printf("Input value \"%s\" is not decimal.\n", string_hex.c_str());
        return -1;
    }
    else
    {
        *value_dec = dec;
    }

    return 0;
}



COMMAND_TYPE
StringParser::convertCommandStringToEnum(string command)
{
    if (command == "")          return NO_COMMAND;
    if (command == HELP)        return CMD_HELP;
    if (command == "list")      return CMD_LIST;
    if (command == "show")      return CMD_SHOW;
    if (command == "utility")   return CMD_UTILITY;
    if (command == "test")      return CMD_TEST;
    if (command == "error")     return CMD_ERROR;
    if (command == "mac")       return CMD_MAC;
    if (command == "eeprom")    return CMD_EEPROM;
    if (command == "sfp")       return CMD_SFP;
    if (command == "set")       return CMD_SET;
    if (command == "accuracy")  return CMD_ACCURACY;
    if (command == "fan")       return CMD_FAN;
    if (command == "led")       return CMD_LED;
    if (command == "temp")      return CMD_TEMP;
    if (command == "fw")        return CMD_FW;
    if (command == "wwn")       return CMD_WWN;
    if (command == "flash")     return CMD_FLASH;
    if (command == "risc")      return CMD_RISC;
    if (command == "guid")      return CMD_GUID;
    if (command == "charge")    return CMD_CHARGE;
    if (command == "ecc")       return CMD_ECC;
    if (command == "spad")      return CMD_SPAD;
    if (command == "program")   return CMD_PROGRAM;
    //Add new command here for enum

    return UNSUPPORT_COMMAND;
}



OPERATION_TYPE
StringParser::convertOperationStringToEnum(string operation)
{
    if (operation == "")          return NO_OPRATION;
    if (operation == HELP)        return OPERATION_HELP;
    if (operation == "read")      return OPERATION_READ;
    if (operation == "write")     return OPERATION_WRITE;
    if (operation == "wrc")       return OPERATION_WRC;
    //Add new operation here for enum

    return UNSUPPORT_OPERATION;
}



int
StringParser::isHEXString(string stringBuffer)
{
    char stringTemp[60];
    int  number, index;

    number = stringBuffer.length();
    stringBuffer.copy(stringTemp, number, 0);

    for (index = 0; index < number; index++)
    {
        if ( index == 1 && (stringTemp[index] == 'x' || stringTemp[index] == 'X'))
            continue;

        if (isxdigit(stringTemp[index]) == 0)
        {
            //printf("Fail  [%d]%c\n", i, buffer[i]);
            return 1;
        }
    }

    return 0;
}



int
StringParser::convertIntToArrary(int inData, int *outData, int *outCount)
{
    int err;
    int index, mask, tempData;

    mask =0xFF;
    err = 0;
    *outCount = 0;
    index = 0;

    do
    {
        /*if (inData == 0)
        {
            break;
        }*/
        outData[index] = inData & mask;

        inData = inData >> 8;
        //(*outCount)++;
        index++;
    }
    while (inData != 0);

    *outCount = index;

    //Revers the array content
    for (index = 0; index < (*outCount)/2; index++)
    {
        tempData = outData[index];
        outData[index] = outData[(*outCount) - index - 1];
        outData[(*outCount) - index - 1] = tempData;
    }

    return err;
}



int
StringParser::convertHexStringToArrary(string inData, int *outData, int *outCount)
{
    int      position, err;
    unsigned i;
    string   separateString, buffer;

    position = 0;
    *outCount = 0;
    err = 0;

    if (inData.compare(0,2,"0x") == 0 || inData.compare(0,2,"0X") == 0)
    {
        //printf("Find \"0x\" at start!!! \n");
        position = 2;
    }

    //Remove prefix "0x" or "0X"
    separateString = inData.substr(position, inData.length() - position);

    if ((separateString.length() % 2) == 0)
    {
        for (i = 0; i < (separateString.length() / 2); i++)
        {
            buffer = separateString.substr(i * 2, 2);
            sscanf(buffer.c_str(), "%x", &outData[*outCount]);
            (*outCount)++;
        }
    }
    else
    {
        buffer = separateString.substr(0, 1);
        sscanf(buffer.c_str(), "%x", &outData[*outCount]);
        (*outCount)++;

        for (i = 0; i < (separateString.length() / 2); i++)
        {
            buffer = separateString.substr((i * 2) + 1, 2);
            sscanf(buffer.c_str(), "%x", &outData[*outCount]);
            (*outCount)++;
        }
    }

    return err;
}



int
StringParser::check_rearrange_argv(char *parameter)
{
    int length = 0, i;

    if (parameter[0] == '-')
    {
        length = strlen(parameter);
        for (i = 0; i < length; i++)
        {
            parameter[i] = parameter[i+1];
        }
        return 1;
    }
    return 0;
}


