#include "OperationBaseClass.hpp"



OperationBaseClass::OperationBaseClass(OPERATION_TYPE opration_type, string helpContent)
{
    switch (opration_type)
    {
        case OPERATION_READ:
        case OPERATION_CONFIG_READ:
        case OPERATION_READ_MAC:
        case OPERATION_READ_EEPROM:
        case OPERATION_READ_SFP:
            m_operation_name = "read";
            break;
        case OPERATION_WRITE:
        case OPERATION_CONFIG_WRITE:
        case OPERATION_WRITE_MAC:
        case OPERATION_WRITE_EEPROM:
        case OPERATION_WRITE_SFP:
            m_operation_name = "write";
            break;
        case OPERATION_DUMP:
            m_operation_name = "dump";
            break;
        case OPERATION_PCI:
            m_operation_name = "pci";
            break;
        case OPERATION_EEPROM:
            m_operation_name = "eeprom";
            break;
        case OPERATION_HBA:
            m_operation_name = "hba";
            break;
        case OPERATION_SWITCH:
            m_operation_name = "switch";
            break;
        case OPERATION_MUXTest:
            m_operation_name = "muxtest";
            break;
        case OPERATION_PreventionStuck:
            m_operation_name = "preventionstuck";
            break;
        case OPERATION_ALL:
        case OPERATION_ERROR_ALL:
            m_operation_name = "all";
            break;
        case OPERATION_ID:
            m_operation_name = "id";
            break;
        case OPERATION_SHOW_SPEED:
        case OPERATION_SPEED:
            m_operation_name = "speed";
            break;
        case OPERATION_SHOW_WIDTH:
            m_operation_name = "width";
            break;
        case OPERATION_LINK:
        case OPERATION_SHOW_LINK:
            m_operation_name = "link";
            break;
        case OPERATION_CLASS_TYPE:
            m_operation_name = "classtype";
            break;
        case OPERATION_PORT_TYPE:
            m_operation_name = "porttype";
            break;
        case OPERATION_WRC:
            m_operation_name = "wrc";
            break;
        case OPERATION_PATH:
            m_operation_name = "path";
            break;
        case OPERATION_CLEAR:
            m_operation_name = "clear";
            break;
        case OPERATION_TEST_RANGE:
            m_operation_name = "testrange";
            break;
        case OPERATION_INFO:
            m_operation_name = "info";
            break;
        case OPERATION_MONITOR:
            m_operation_name = "monitor";
            break;
        case OPERATION_ADDR_LINE:
            m_operation_name = "addrline";
            break;
        case OPERATION_DATA_LINE:
            m_operation_name = "dataline";
            break;
        case OPERATION_MARCHC:
            m_operation_name = "marchc";
            break;
        case OPERATION_PATTERN:
            m_operation_name = "pattern";
            break;
        case OPERATION_RANDOM:
            m_operation_name = "random";
            break;
        case OPERATION_CHECKSUM:
            m_operation_name = "checksum";
            break;
        case OPERATION_PORT:
            m_operation_name = "port";
            break;
        case OPERATION_NODE:
            m_operation_name = "node";
            break;
        case OPERATION_SHOW_IRQ:
            m_operation_name = "irq";
            break;
        case OPERATION_UART_PORT_TYPE:
        case OPERATION_PROTOCOL_TYPE:
        case OPERATION_ATTACHED_TYPE:
            m_operation_name = "type";
            break;
        case OPERATION_SCRATCHPAD_TEST:
            m_operation_name = "scratchpad";
            break;
        case OPERATION_INTERNAL_LOOPBACK_TEST:
            m_operation_name = "internalloopback";
            break;
        case OPERATION_SINGLE_LOOPBACK_TEST:
            m_operation_name = "singleloopback";
            break;
        case OPERATION_CROSS_LOOPBACK_TEST:
            m_operation_name = "crossloopback";
            break;
        case OPERATION_RETRAIN_LINK:
            m_operation_name = "retrainlink";
            break;
        case OPERATION_ON:
            m_operation_name = "on";
            break;
        case OPERATION_OFF:
            m_operation_name = "off";
            break;
        case OPERATION_CHECK:
            m_operation_name = "check";
            break;
        case OPERATION_PCI_COMPATIBLE:
            m_operation_name = "pci-comatible";
            break;
        case OPERATION_PCIE:
            m_operation_name = "pcie";
            break;
        case OPERATION_AER:
            m_operation_name = "aer";
            break;
        case OPERATION_TEST:
            m_operation_name = "test";
            break;
        case OPERATION_PROGRAM:
            m_operation_name = "program";
            break;
        case OPERATION_SAVE:
            m_operation_name = "save";
            break;
        case OPERATION_FW:
            m_operation_name = "fw";
            break;
        case OPERATION_MDI:
            m_operation_name = "mdi";
            break;
        case OPERATION_INTERRUPT:
            m_operation_name = "interrupt";
            break;
        case OPERATION_EXTERNAL_LOOPBACK_TEST:
            m_operation_name = "crossloopback";
            break;
        case OPERATION_INJECT:
            m_operation_name = "inject";
            break;
        case OPERATION_RETRAIN:
            m_operation_name = "retrain";
            break;
        case OPERATION_SEARCH:
            m_operation_name = "search";
            break;
        case OPERATION_CHARGE:
            m_operation_name = "charge";
            break;
        case OPERATION_VALIDATE_EEPROM:
            m_operation_name = "validate";
            break;
        case OPERATION_DATE:
            m_operation_name = "date";
            break;
        case OPERATION_TIME:
            m_operation_name = "time";
            break;
        case OPERATION_DATETIME:
            m_operation_name = "datetime";
            break;
        case OPERATION_ACCURACY:
            m_operation_name = "accuracy";
            break;
        case OPERATION_WDT:
            m_operation_name = "wdt";
            break;
        case OPERATION_PSU:
            m_operation_name = "psu";
            break;
        case OPERATION_FAN:
            m_operation_name = "fan";
            break;
        case OPERATION_LED:
            m_operation_name = "led";
            break;
        case OPERATION_TEMP:
            m_operation_name = "temp";
            break;
        case OPERATION_THRESHOLD:
            m_operation_name = "threshold";
            break;
        case OPERATION_VENDOR:
            m_operation_name = "vendor";
            break;
        case OPERATION_CHIP:
            m_operation_name = "chip";
            break;
        case OPERATION_PN:
            m_operation_name = "pn";
            break;
        case OPERATION_SN:
            m_operation_name = "sn";
            break;
        case OPERATION_MAX_POWER:
            m_operation_name = "max_power";
            break;
        case OPERATION_GET:
            m_operation_name = "get";
            break;
        case OPERATION_SET:
            m_operation_name = "set";
            break;
        case OPERATION_RANGE:
            m_operation_name = "range";
            break;
        case OPERATION_STATUS:
            m_operation_name = "status";
            break;
        case OPERATION_FAMILY:
            m_operation_name = "family";
            break;
        case OPERATION_SELFTEST:
            m_operation_name = "selftest";
            break;
        case OPERATION_CMD:
            m_operation_name = "cmd";
            break;
        case OPERATION_SHOW_CPU:
            m_operation_name = "cpu";
            break;
        case OPERATION_SHOW_VENDOR:
            m_operation_name = "vendor";
            break;
        case OPERATION_SHOW_MODEL:
            m_operation_name = "model";
            break;
        case OPERATION_SHOW_FAMILY:
            m_operation_name = "family";
            break;
        case OPERATION_SHOW_CORE:
            m_operation_name = "core";
            break;
        case OPERATION_SHOW_FREQUENCY:
            m_operation_name = "frequency";
            break;
        case OPERATION_SHOW_STEPPING:
            m_operation_name = "stepping";
            break;
        case OPERATION_SHOW_CACHE:
            m_operation_name = "cache";
            break;
        case OPERATION_SHOW_TEMPERATUR:
            m_operation_name = "temperature";
            break;
        case OPERATION_STABILITY:
            m_operation_name = "stability";
            break;
        case OPERATION_UTILITY_GETMCE:
            m_operation_name = "getmce";
            break;
        case OPERATION_SEND:
            m_operation_name = "send";
            break;
        case OPERATION_RECEIVED:
            m_operation_name = "receive";
            break;
        case OPERATION_SERVER:
            m_operation_name = "server";
            break;
        case OPERATION_CLIENT:
            m_operation_name = "client";
            break;
        case OPERATION_CONTROLLER:
            m_operation_name = "controller";
            break;
        case OPERATION_PHY:
            m_operation_name = "phy";
            break;
        case OPERATION_ADDRESS:
            m_operation_name = "address";
            break;
        case OPERATION_RESET_CONTROLLER:
            m_operation_name = "reset";
            break;
        case OPERATION_DISPARITY_ERR:
            m_operation_name = "disparity";
            break;
        case OPERATION_INVALID_DWORD_ERR:
            m_operation_name = "invalid_dword";
            break;
        case OPERATION_LOSS_DWORD_SYNC:
            m_operation_name = "loss_dword_sync";
            break;
        case OPERATION_PHY_RESET_PRBM:
            m_operation_name = "phy_reset_prbm";
            break;
        case OPERATION_DESIGN_ID:
            m_operation_name = "designid";
            break;
        case OPERATION_ERROR_STATISTICS:
            m_operation_name = "statistics";
            break;
        case OPERATION_ERROR_PCI:
            m_operation_name = "pci";
            break;
        case OPERATION_INIT:
            m_operation_name = "init";
            break;
        case OPERATION_PERFORMANCE:
            m_operation_name = "performance";
            break;
        default:
            m_operation_name = "";
            break;
    }
    
    m_help_content = helpContent;
    m_opration_type = opration_type;
    
    for (int i=0; i<PARAMETER_NUMBER; i++)
    {
        m_parameter[i] = "";
    }
    m_parameter_count = 0;
}



OperationBaseClass::~OperationBaseClass()
{
	
}



int
OperationBaseClass::getName(string *operation_name)
{
    *operation_name = m_operation_name;
    return 0;
}



int
OperationBaseClass::setName(string opration_name)
{
    m_operation_name = opration_name;
    return 0;
}



int
OperationBaseClass::getHelp(string *help_content)
{
    *help_content = m_help_content;
    return 0;
}



int
OperationBaseClass::setHelp(string help_content)
{
    m_help_content = help_content;
    return 0;
}


OPERATION_TYPE
OperationBaseClass::getOperationType()
{
    return m_opration_type;
}


int
OperationBaseClass::setOperationType(OPERATION_TYPE operation_type_id)
{
    m_opration_type = operation_type_id;
    return 0;
}



int
OperationBaseClass::executeOperation(StringParser command_line)
{
    return 0;
}



int
OperationBaseClass::helpParameter()
{
    return 0;
}



int
OperationBaseClass::syntaxCheck(StringParser command_line)
{
    return 0;
}



int
OperationBaseClass::setAllParameter(StringParser command_line)
{
    string parameter_temp;
    int i;
    
    for (i=0; i<m_parameter_count; i++)
    {
        command_line.getParameter(&parameter_temp, i);
        m_parameter[i] = parameter_temp;
    }
	
    return 0;
}



int
OperationBaseClass::getParameter(string *parameter, int index)
{
    if (index < 0)
    {
        cout << "index less 0" << endl;
        return -1;
    }
    else if(index > PARAMETER_NUMBER)
    {
        cout << "index great than max value" << endl;
        return -1;
    }

    *parameter = m_parameter[index];
    
    return 0;
}
