#ifndef NTBOperation_H
#define NTBOperation_H

#include "OperationBaseClass.hpp"
#include "NTBDAPI.hpp"
#include "PCIDAPI.hpp"


#define NTB_DEBUG_LEVEL DEBUG_LEVEL_1
//#define NTB_DEBUG_LEVEL DEBUG_LEVEL_2 //debug mode


typedef struct _IO_PARMS
{
    UINT64  u64PatternSend;
    UINT64  u64PatternRev;
    UINT32  u32Loop;
    string  name;
}IO_PARMS;


class NTBOperation : public OperationBaseClass
{
    public:
                 NTBOperation(OPERATION_TYPE, string);
        virtual ~NTBOperation();

        int executeOperation(StringParser command_line);

    private:
        int             m_s32Result;
        NTBDAPI*        m_pNTBDAPI;
        PCIDAPI*        m_pPCIDAPI;
        ErrorMsg*       m_pErrorMsg;
        string          m_strParameter[PARAMETER_NUMBER];
        int             m_s32ParameterAmount;

        void    showHelp();
        void    showHelpSC(UINT64 in_u64WritePat,
                           UINT64 in_u64ReadPat);

        int     checkSyntax(StringParser);
        int     checkSyntaxSC(StringParser);

        int     showSpecificInfo(PFA, OPERATION_TYPE);
        int     showInfo(string in_ntbName);
        int     clearErrors(string in_ntbName);

        int     showErrorStatistics(string  in_ntbName,
                                    UINT8   in_interface);

        int     getDeviceBDF(string   in_ntbName,
                             PFA*     out_pBDF);

        int     checkName(string  in_name);

        int     server(StringParser);
        int     client(StringParser);
        int     initialWindow(StringParser);
        int     testPerformance(StringParser);

        void    getIoParms(StringParser   in_classCommandLine,
                           UINT64         in_defWritePat,
                           UINT64         in_defReadPat, 
                           IO_PARMS*      out_ioParms);
};

#endif

