#ifndef NVMe_OPERATION_H
#define NVMe_OPERATION_H

#include <stdio.h>
#include <iostream>
#include <string>
#include <thread>

#include "OperationBaseClass.hpp"
#include "PCIDAPI.hpp"
#include "NVMeDAPI.hpp"
#include "StorageDAPI.hpp"
#include "NVMePrint.hpp"

enum {
    TERSE = 0x1u,   // only show a few useful fields
    HUMAN = 0x2u,   // interpret some values for humans
    VS    = 0x4u,   // print vendor specific data area
    RAW   = 0x8u,   // just dump raw bytes
};

class NVMeOperation: public OperationBaseClass
{
    public:
        NVMeOperation(OPERATION_TYPE, string);
        virtual ~NVMeOperation();

        	//Decide which operation to be executed
        	int executeOperation(StringParser);

	        //List NVMe device node
	        int executeListNVMe(StringParser);

	        //Show NVMe controller characteristics
	        int executeShowController(StringParser);

	        //Execute Error command
	        INT32 executeError(StringParser);

	        //Execute clear Error command
	        INT32 executeClearError(StringParser);

	        //Execute Utility command
	        INT32 executeUtility(StringParser);

	        //Execute Utility command
	        INT32 executeActivateFW(StringParser);

	        //Execute Utility command
	        INT32 executeDownloadFW(StringParser);

	        //Execute test command
	        int executeTest(StringParser);

			int executeGetFeatures(StringParser);

			int executeSetFeatures(StringParser);

	        //Show parameter message here
	        void showOperationHelp();

            //Check parameter syntax here
            int checkSyntax(StringParser);

    private:

        void handleTestProgress(UINT32 in_u32TestSizeMB);

};

#endif
