#ifndef NVSRAM_OPERATION_H
#define NVSRAM_OPERATION_H

#include <stdio.h>
#include <iostream>
#include <string>
#include "OperationBaseClass.hpp"
#include "NVSRAMDAPI.hpp"
#include "MemoryDAPI.hpp"

class NVSRAMOperation: public OperationBaseClass
{
    public:
        NVSRAMOperation(OPERATION_TYPE, string);
        virtual ~NVSRAMOperation();

        //Decide which operation to be executed
        int executeOperation(StringParser);

        //Show NVSRAM device characteristics
        int executeShow(StringParser);

        //Execute test command
        int executeTest(StringParser);

        //Show parameter message here
        int helpParameter();

        //Check parameter syntax here
        int checkSyntax(StringParser);

    private:
        OPERATION_TYPE operationType;
        NVSRAMDAPI* nvsramDAPI;
        MemoryDAPI* memDAPI;
};

#endif
