#include "StabilityTest.hpp"

bdata bd[MAX_THREADS];
bool stoppressed;

StabilityTestObject::StabilityTestObject(STRING className) : BaseClassDAPI(className)
{
   /* Default settings */
   iter = 16;
   threads = 16;
   algo = 0;
   mode = 0;
   errors = 0;
   m_errorCode = NO_ERROR_MSG;
}



StabilityTestObject::~StabilityTestObject()
{

}



ErrorMsg*
StabilityTestObject::PiCalculate(INT32 *test_result, int display, int loop)
{
    st_thread_t    th[MAX_THREADS];
    st_threadret_t rth[MAX_THREADS];

    mp_exp_t expvar;
    unsigned long long prec = 0, bits, i = 0/*, n = 1*/;
    int  p[MAX_THREADS], k = 0;
    char *pistr = NULL;
    char /*column[111] = "",*/ pxdigits[13] = "", ptime[13] = "", failtime[13] = "No fail yet", xstr[256] = " N/A ";
    int  memory_available;

    //Check system available memory is enough for used
    m_errorCode = check_system_memory_available(loop);
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_PROCESSOR_DAPI_STABILITY_TEST, NULL, m_errorCode);
    }

    if (loop != 0) // '0' is default, iter = 16
    {
       iter = loop;
    }

//   if (algo == 0)		/* Borwein */
     prec = 4;
//   else if (algo == 1)	/* Gauss */
//     prec = 2;

    if (iter < 4)
    {
        iter = 4;
    }
    /*
     * Calculate precision xdigits
     */
    for (i = 0; i < iter - 1; i++)
    {
        prec += prec;
    }
    xdigits = prec;
//  pth_stacksize = xdigits * 2;
    bits = (unsigned long) ((prec / 9) * 32) + 2;

    if (display == 1)
       PRINT (" Calculating %ld digits of pi\n", (unsigned long) xdigits);


    /*
     * Initialize the mpf's
     */
    start = pitimer ();
    mpf_set_default_prec (bits);
//  if (algo == 0)		/* Borwein */
    prec = 2;
//  else if (algo == 1)		/* Gauss */
//    prec = 1;


    stop = pitimer ();
    outtime (start, stop, ptime);

    for (k = 0; k < threads; k++)
    {
         p[k] = k;
         if (algo == 0)
         {
	   rth[k] =
	     st_thread_create (&th[p[k]], borwein_initialize,
                        (st_threadfuncarg_t) & p[k]);
         }

//      else if (algo == 1)
//	rth[k] =
//	  st_thread_create (&th[p[k]], gl_initialize,
//			    (st_threadfuncarg_t) & p[k]);
    }

    if (display == 1)
    {
      /* PRINT ("%s", " -----------------------------------------\n");
       PRINT (" Turn:%4d  ", pass);
       PRINT ("Errors:%4d       ", errors);
       PRINT ("Threads:%4d\n", threads);
       PRINT (" Running For: %12s  ", ptime);
       PRINT ("ChkErr:%4d\n", chksum_err);
       PRINT (" Failed After: %12s\n", failtime);
       PRINT ("%s", " -----------------------------------------\n");*/
       PRINT ("%s", " Loop Digits State    Time\n");
       PRINT ("%s", " ---------------------------------\n");
       outxdigits (prec, pxdigits);

       PRINT (" %4d", 0);
       PRINT (" %6s ", pxdigits);
     //PROCESS_EVENTS;
    }

    st_thread_join (threads, th, rth);

    stop = pitimer ();
    if ((threads == 1) || (mode == 1))
    {
        sprintf (xstr, " N/A ");
    }
    if ((threads > 1) && (mode == 0))
    {
        sprintf (xstr, " OK ");
        for (k = 1; k < threads; k++)

        if (algo == 0)		/* Borwein */
        {
	    if (mpf_cmp (bd[k - 1].p1, bd[k].p1) != 0)
	    {
		sprintf (xstr, " BAD ");
		errors++;
		if (first_error == 0)
		{
		    first_error = pitimer ();
		    outtime (start, first_error, failtime);
		}
		goto lbl100_exit;
	    }
        }
//	else if (algo == 1)	/*Gauss */
/*	  {
	    if (mpf_cmp (gd[k - 1].t, gd[k].t) != 0)
	      {
		sprintf (xstr, " BAD ");
		errors++;
		if (first_error == 0)
		  {
		    first_error = pitimer ();
		    outtime (start, first_error, failtime);
		  }
		goto lbl100_exit;
	      }
	  }*/
    }

    if (display == 1)
    {
       PRINT ("%s", xstr);

       outtime (start, stop, ptime);
       PRINT (" %s\n", ptime);
    }

    /*
     * The main loop
     */
    //  if (algo == 0)		/* Borwein */
        prec = 4;
    //  else if (algo == 1)		/* Gauss */
    //    prec = 2;
    i = 0;
    while (i < (iter - 1))
    {
        if (stoppressed == TRUE)
            goto lbl100_exit;

        outxdigits (prec, pxdigits);
        if (display == 1)
        {
            PRINT (" %4d", (int) (i + 1));
            PRINT (" %6s ", pxdigits);
            // PROCESS_EVENTS;
        }

        for (k = 0; k < threads; k++)
            if (algo == 0)
                rth[k] =st_thread_create (&th[p[k]], borwein_calculate,
                                          (st_threadfuncarg_t) &p[k]);
        /*   else if (algo == 1)
        rth[k] =
            st_thread_create (&th[p[k]], gl_calculate,
                             (st_threadfuncarg_t) & p[k]);
        */

        st_thread_join (threads, th, rth);
        stop = pitimer ();

        if ((threads == 1) || (mode == 1))
            sprintf (xstr, " N/A ");

        if ((threads > 1) && (mode == 0))
        {
            sprintf (xstr, " OK ");
            for (k = 1; k < threads; k++)

            if (algo == 0)  /* Borwein */
            {
                if (mpf_cmp (bd[k - 1].p1, bd[k].p1) != 0)
                {
                    sprintf (xstr, " BAD ");
                    errors++;
                    if (first_error == 0)
                    {
                        first_error = pitimer ();
                        outtime (start, first_error, failtime);
                    }
                    goto lbl100_exit;
                }
            }
          //else if (algo == 1)	/*Gauss */
          /*{
                if (mpf_cmp (gd[k - 1].t, gd[k].t) != 0)
                {
                    sprintf (xstr, " BAD ");
                    errors++;
                    if (first_error == 0)
                    {
                        first_error = pitimer ();
                        outtime (start, first_error, failtime);
                    }
                    goto lbl100_exit;
                }
            }*/
        }
        if (display == 1)
        {
            PRINT ("%s", xstr);
            outtime (start, stop, ptime);
            PRINT (" %s\n", ptime);
            //PROCESS_EVENTS;
        }

        /*
         * Calculate the precision of the next pass
         */
        prec += prec;
        i++;

        //Show process percentage
        printf("%.1f%\r", i/(float)(iter)*100);
        fflush(stdout);
    }


/*
 * The last pass is here. We don't need to prepare the next one
 */
  outxdigits (prec, pxdigits);
  if (display == 1)
  {
     PRINT (" %4d", (int) (i + 1));
     PRINT (" %6s ", pxdigits);
  }
//  PROCESS_EVENTS;

  for (k = 0; k < threads; k++)
    if (algo == 0)
      rth[k] =
	st_thread_create (&th[p[k]], borwein_finalize,
			  (st_threadfuncarg_t) & p[k]);
/*    else if (algo == 1)
      rth[k] =
	st_thread_create (&th[p[k]], gl_finalize,
			  (st_threadfuncarg_t) & p[k]);
*/
  st_thread_join (threads, th, rth);
  stop = pitimer ();

  if ((threads == 1) || (mode == 1))
    sprintf (xstr, " N/A ");
  if ((threads > 1) && (mode == 0))
  {
      sprintf (xstr, " OK ");
      for (k = 1; k < threads; k++)
      {
	  if (algo == 0)	/* Borwein */
	  {
	      if (mpf_cmp (bd[k - 1].p1, bd[k].p1) != 0)
              {
		  sprintf (xstr, " BAD ");
		  errors++;
		  if (first_error == 0)
		  {
		      first_error = pitimer ();
		      outtime (start, first_error, failtime);
		  }
		  goto lbl100_exit;
              }
	  }
//	  else if (algo == 1)	/*Gauss */
/*	    {
	      if (mpf_cmp (gd[k - 1].t, gd[k].t) != 0)
		{
		  sprintf (xstr, " BAD ");
		  errors++;
		  if (first_error == 0)
		    {
		      first_error = pitimer ();
		      outtime (start, first_error, failtime);
		    }
		  goto lbl100_exit;
		}
	    }*/
      }
  }
  if (display == 1)
  {
     PRINT ("%s", xstr);
     outtime (start, stop, ptime);
     PRINT (" %s\n", ptime);
   //PROCESS_EVENTS;
  }
  printf("%.1f%\n", i/(float)(iter-1)*100);

  outtime (start, stop, ptime);
  PRINT ("Time: %s\n", ptime);

  pistr = (char *) malloc (prec + 100);
  if (algo == 0)
    mpf_get_str (pistr, &expvar, 10, prec, bd[0].p2);
//  else if (algo == 1)
//    mpf_get_str (pistr, &expvar, 10, prec, gd[0].pi);

//gmp_printf("\n%.Ff\n", bd[0].p2);

/*
 * Checksum validation
 */
  if (display == 1)
  {
     PRINT ("%s", " Checksum validation...");

   //  if (algo == 0)
       PRINT ("%s", "Borwein");

   //  if (algo == 1)
   //    PRINT ("%s", "Gauss");
  }

  if (validate_checksum (prec, pistr))
  {
    sprintf (xstr, " PASSED!!!\n");
    *test_result = 1;
  }
  else
  {
      sprintf (xstr, " FAILED!!!\n");
      chksum_err++;
      *test_result = 0;
  }

  if (display == 1)
     PRINT ("%s", xstr);


/*
 * Now exiting
 */
lbl100_exit:
/*
 * Log
 */

/*  if (lflag)
    {
      //logfile = fopen ("systester.log", "a+");
      logfile = fopen (LOG_FILE_PATH, "a+");
      fprintf (logfile, " Turn:%4d  Errors:%4d  Threads:%4d", pass, errors,
	       threads);
      fprintf (logfile,
	       " Running For: %12s Failed After: %12s - Checksum Errors: %4d%c%c",
	       ptime, failtime, chksum_err, 10, 13);
      fclose (logfile);
    }*/

  if (stoppressed == TRUE)
  {
      PRINT ("%s", "Interrupted by user \n\n");
//      PROCESS_EVENTS;
  }

  if (algo == 0)		/* Borwein */
  {
      for (i = 0; (signed)i < threads; i++)
      {
	  mpf_clear (bd[i].x1);
	  mpf_clear (bd[i].x2);
	  mpf_clear (bd[i].p1);
	  mpf_clear (bd[i].p2);
	  mpf_clear (bd[i].w1);
	  mpf_clear (bd[i].w2);
	  mpf_clear (bd[i].sqrx);
	  mpf_clear (bd[i].sqr1x);
	  mpf_clear (bd[i].x2plus1);
	  mpf_clear (bd[i].w1plus1);
	  mpf_clear (bd[i].x2divw1);
      }
  }
//  else if (algo == 1)		/* Gauss */
/*    {
      for (i = 0; i < threads; i++)
	{
	  mpf_clear (gd[i].a);
	  mpf_clear (gd[i].a2);
	  mpf_clear (gd[i].b);
	  mpf_clear (gd[i].b2);
	  mpf_clear (gd[i].t);
	  mpf_clear (gd[i].p);
	  mpf_clear (gd[i].p2);
	  mpf_clear (gd[i].aplus1);
	  mpf_clear (gd[i].bplus1);
	  mpf_clear (gd[i].tplus1);
	  mpf_clear (gd[i].pplus1);
	  mpf_clear (gd[i].temp1);
	  mpf_clear (gd[i].temp2);
	  mpf_clear (gd[i].pi);
	}
    }*/

/*
  for (k = 0; k < threads; k++)
    thread_cancel (th[p[k]]);
*/

  if (pistr != NULL)
    free (pistr);

  return NO_ERROR_MSG;
}



st_threadfunc_t
borwein_initialize
   (
   st_threadfuncarg_t idx
   )
{

  int i;
  memcpy (&i, idx, sizeof (int));
  mpf_init (bd[i].x1);
  mpf_init (bd[i].x2);
  mpf_init (bd[i].p1);
  mpf_init (bd[i].p2);
  mpf_init (bd[i].w1);
  mpf_init (bd[i].w2);
  mpf_init (bd[i].sqrx);
  mpf_init (bd[i].sqr1x);
  mpf_init (bd[i].x2plus1);
  mpf_init (bd[i].w1plus1);
  mpf_init (bd[i].x2divw1);

  /*
   * Calculate the initial values 
   */
  mpf_set_d (bd[i].x1, 2.0);
  mpf_sqrt (bd[i].x1, bd[i].x1);
  mpf_add_ui (bd[i].p1, bd[i].x1, 2);
  mpf_sqrt (bd[i].w1, bd[i].x1);

  /*
   * Borwein Algorithm 
   */
  mpf_sqrt (bd[i].sqrx, bd[i].x1);
  mpf_ui_div (bd[i].sqr1x, 1, bd[i].sqrx);
  return (st_threadfunc_t) NULL;
}


/*
 *  Step 1 of the calculation: X(i+1), [X(i+1) + 1]
 */
static st_threadfunc_t
borwein_step_1 (st_threadfuncarg_t idx)
{
  int i;
  memcpy (&i, idx, sizeof (int));
  /*
   * Calculate X(i+1) 
   */
  mpf_add (bd[i].x2, bd[i].sqrx, bd[i].sqr1x);
  mpf_div_ui (bd[i].x2, bd[i].x2, 2);

  /*
   * Calculate [X(i+1) + 1] 
   */
  mpf_add_ui (bd[i].x2plus1, bd[i].x2, 1);
  return (st_threadfunc_t) NULL;
}


/*
 *  Step 2 of the calculation: [Y(i+1) + 1] 
 */
static st_threadfunc_t
borwein_step_2 (st_threadfuncarg_t idx)
{
  int i;
  memcpy (&i, idx, sizeof (int));
  /*
   * Calculate [Y(i+1) + 1] 
   */
  mpf_add_ui (bd[i].w1plus1, bd[i].w1, 1);
  return (st_threadfunc_t) NULL;
}

/*
 *  Step 3 of the calculation: [X(i+1) + 1] / [Y(i+1) + 1], P(i+1) 
 */
static st_threadfunc_t
borwein_step_3 (st_threadfuncarg_t idx)
{
  int i;
  memcpy (&i, idx, sizeof (int));
  /*
   * Calculate [X(i+1) + 1] / [Y(i+1) + 1] 
   */
  mpf_div (bd[i].x2divw1, bd[i].x2plus1, bd[i].w1plus1);

  /*
   * Calculate P(i+1) 
   */
  mpf_mul (bd[i].p2, bd[i].p1, bd[i].x2divw1);
  return (st_threadfunc_t) NULL;
}


/*
 *  Step 4 of the calculation: SQR X(i+1), 
 *                             1/SQR X(i+1), 
 *                             Y(i) * SQR X(i+1),
 *                             [Y(i) * SQR X(i+1)] + [1 / SQR X(i+1)],
 *                             Y(i) + 1, 
 *                             Y(i+1) 
 */


static st_threadfunc_t
borwein_step_4 (st_threadfuncarg_t idx)
{
  int i;
  memcpy (&i, idx, sizeof (int));


  /*
   * Calculate SQR X(i+1) 
   */
  mpf_sqrt (bd[i].sqrx, bd[i].x2);

  /*
   * Calculate 1/SQR X(i+1) 
   */
  mpf_ui_div (bd[i].sqr1x, 1, bd[i].sqrx);

  /*
   * Calculate Y(i) * SQR X(i+1) 
   */
  mpf_mul (bd[i].w2, bd[i].w1, bd[i].sqrx);

  /*
   * Calculate [Y(i) * SQR X(i+1)] + [1 / SQR X(i+1)] 
   */
  mpf_add (bd[i].w2, bd[i].w2, bd[i].sqr1x);

  /*
   * Calculate Y(i) + 1 
   */
  mpf_add_ui (bd[i].w1, bd[i].w1, 1);

  /*
   * Calculate Y(i+1) 
   */
  mpf_div (bd[i].w2, bd[i].w2, bd[i].w1);
  return (st_threadfunc_t) NULL;

}



st_threadfunc_t
borwein_calculate
   (
   st_threadfuncarg_t idx
   )
{
  st_thread_t th[2];
  st_threadret_t rth[2];

  int i;

  memcpy (&i, idx, sizeof (int));

  rth[0] = st_thread_create (&th[0], borwein_step_1, idx);
  rth[1] = st_thread_create (&th[1], borwein_step_2, idx);
  st_thread_join (2, th, rth);

#if !defined (_TEST)
  if (stoppressed == TRUE)
    return (st_threadfunc_t) NULL;
#endif

  rth[0] = st_thread_create (&th[0], borwein_step_3, idx);
  rth[1] = st_thread_create (&th[1], borwein_step_4, idx);
  st_thread_join (2, th, rth);


#if !defined (_TEST)
  if (stoppressed == TRUE)
    return (st_threadfunc_t) NULL;
#endif

  /*
   * Set the results to the initial variables for recursion 
   */
  mpf_set (bd[i].x1, bd[i].x2);
  mpf_set (bd[i].p1, bd[i].p2);
  mpf_set (bd[i].w1, bd[i].w2);

  return (st_threadfunc_t) NULL;

}



st_threadfunc_t
borwein_finalize
   (
   st_threadfuncarg_t idx
   )
{

  int i;

  memcpy (&i, idx, sizeof (int));

  /*
   * Calculate X(i+1) 
   */
  mpf_add (bd[i].x2, bd[i].sqrx, bd[i].sqr1x);
  mpf_div_ui (bd[i].x2, bd[i].x2, 2);

  /*
   * Calculate [X(i+1) + 1] 
   */
  mpf_add_ui (bd[i].x2plus1, bd[i].x2, 1);

  /*
   * Calculate [Y(i+1) + 1] 
   */
  mpf_add_ui (bd[i].w1plus1, bd[i].w1, 1);

  /*
   * Calculate [X(i+1) + 1] / [Y(i+1) + 1] 
   */
  mpf_div (bd[i].x2divw1, bd[i].x2plus1, bd[i].w1plus1);

  /*
   * Calculate P(i+1) 
   */
  mpf_mul (bd[i].p2, bd[i].p1, bd[i].x2divw1);
  return (st_threadfunc_t) NULL;

}



st_threadret_t
st_thread_create
   (
   st_thread_t * th,
   st_threadfunc_t (*start_routine) (st_threadfuncarg_t),
   st_threadfuncarg_t arg
   )
{
  return pthread_create (th, NULL, start_routine, arg);
}



void
st_thread_join
   (
   int nthreads,
   st_thread_t * threads,
   st_threadret_t * rthreads
   )
{
  int i;
  for (i = 0; i < nthreads; i++)
    pthread_join (threads[i], NULL);
}



static unsigned short
swapendian16 (unsigned short oldnum)
{
  char *oldn, *newn;
  unsigned short newnum;
  oldn = (char *) &oldnum;
  newn = (char *) &newnum;
  newn[0] = oldn[1];
  newn[1] = oldn[0];

  return newnum;
}



/*
 * Check the endianess of the machine. 0 LE, 1 BE
 */
static unsigned char
machine_endianess (void)
{
  unsigned char *endian;
  short int testnum = 256;
  endian = (unsigned char *) &testnum;
  return endian[0];
}


/*
 *  16 bit version
 */
static unsigned short
checksum16 (unsigned char *data, int len)
{
  unsigned int sum = 0, tmp;

  if (machine_endianess () == 0)	/* Little Endian */
  {
      if ((len & 1) == 0)
	len = len >> 1;
      else
	len = (len >> 1) + 1;
      while (len > 0)
      {
	  sum += *((unsigned short *) data);
	  data += sizeof (unsigned short);
	  len--;
      }

      sum = (sum >> 16) + (sum & 0xffff);
      sum += (sum >> 16);
      return (~sum);
  }

  /* Big Endian */
  if ((len & 1) == 0)
    len = len / 2;
  else
    len = (len / 2) + 1;

  while (len > 0)
  {
      tmp = swapendian16 (*(unsigned short *) data);
      sum += tmp;
      data += sizeof (unsigned short);
      len--;
  }

  sum = (sum << 16) + (sum & 0xffff0000);
  sum += (sum << 16);
  return (~sum >> 16);
}



int
StabilityTestObject::validate_checksum
   (
   int prec,
   char *pistr
   )
{
  int prec_table[11] = {
    131072, 262144, 524288, 1048576, 2097152,
    4194304, 8388608, 16777216, 33554432,
    67108864, 134217728
  }, n;

  unsigned short checksum[11] = {
    21500, 27186, 156, 22100, 14020,
    11126, 19420, 58, 14711, 16470, 60748
  }, validsum;


  validsum = checksum16 ((unsigned char *) pistr, prec);

  n = 0;
loop_top:
  if (prec_table[n] == prec)
  {
      if (validsum == checksum[n])
	return 1;		/* valid checksum - TRUE */
      return 0;			/* invalid checksum - FALSE */
  }

  n++;
  if (n < 11)
    goto loop_top;

  return 0;			/* subscript out of range: return FALSE */
}



void
StabilityTestObject::outxdigits
   (
   unsigned long long xdigits,
   char *str
   )
{
  unsigned long long M = 1024 * 1024, K = 1024;

  if (xdigits >= M)
  {
      sprintf (str, "%dM", (int) (xdigits / M));
      return;
  }

  if (xdigits >= K)
  {
      sprintf (str, "%dK", (int) (xdigits / K));
      return;
  }

  sprintf (str, "%d", (int) xdigits);
}



void
StabilityTestObject::outtime
   (
   unsigned long long start,
   unsigned long long stop,
   char *str
   )
{
  unsigned long long hours = 0, minutes = 0, remainder = 0, total_seconds = 0;
  float seconds;

  total_seconds = (unsigned long long) ((stop - start) / 1000);
  hours = (unsigned long long) (total_seconds / 3600);
  remainder = total_seconds % 3600;
  minutes = (unsigned long long) (remainder / 60);
  seconds =
    (float) ((stop - start) -
	     (((hours * 3600) + (minutes * 60)) * 1000)) / 1000;

  sprintf (str, "%2dh %2dm %6.3fs", (int) hours, (int) minutes, seconds);
}



unsigned
StabilityTestObject::pitimer()
{
  struct timeb tp;
  unsigned long milliseconds;

  ftime (&tp);
  milliseconds = tp.time * 1000 + tp.millitm;

  return milliseconds;
}



ErrorMsg*
StabilityTestObject::check_system_memory_available(int loop)
{
    FILE  *pFile = NULL;
    char  line[500], *pch;
    int   free_memory = 0;

    pFile = fopen("/proc/meminfo","r");
    if (pFile == NULL)
    {
        return returnErrorMsg(ERROR_PROCESSOR_DAPI_STABILITY_TEST, "Open /proc/meminfo fail", NULL);
    }

    while(fgets(line, 500, pFile) != NULL)
    {
        pch = strtok(line, " :");

        if (strcmp("MemAvailable", pch) == 0)
        {
            pch = strtok(NULL, " :");
            sscanf(pch, "%d", &free_memory);
            free_memory = free_memory / 1024;
            break;
        }
    }
    fclose(pFile);

    switch(loop)
    {
        case 16:
            if (free_memory < 60)
                return returnErrorMsg(ERROR_PROCESSOR_DAPI_STABILITY_TEST, "System free memory isn't enough", NULL);
            break;
        case 17:
            if (free_memory < 120)
                return returnErrorMsg(ERROR_PROCESSOR_DAPI_STABILITY_TEST, "System free memory isn't enough", NULL);
            break;
        case 18:
            if (free_memory < 200)
                return returnErrorMsg(ERROR_PROCESSOR_DAPI_STABILITY_TEST, "System free memory isn't enough", NULL);
            break;
        case 19:
            if (free_memory < 400)
                return returnErrorMsg(ERROR_PROCESSOR_DAPI_STABILITY_TEST, "System free memory isn't enough", NULL);
            break;
        case 20:
            if (free_memory < 800)
                return returnErrorMsg(ERROR_PROCESSOR_DAPI_STABILITY_TEST, "System free memory isn't enough", NULL);
            break;
        case 21:
            if (free_memory < 1800)
                return returnErrorMsg(ERROR_PROCESSOR_DAPI_STABILITY_TEST, "System free memory isn't enough", NULL);
            break;
        case 22:
            if (free_memory < 3000)
                return returnErrorMsg(ERROR_PROCESSOR_DAPI_STABILITY_TEST, "System free memory isn't enough", NULL);
            break;
        case 23:
            if (free_memory < 3500)
                return returnErrorMsg(ERROR_PROCESSOR_DAPI_STABILITY_TEST, "System free memory isn't enough", NULL);
            break;
        case 24:
            if (free_memory < 4000)
                return returnErrorMsg(ERROR_PROCESSOR_DAPI_STABILITY_TEST, "System free memory isn't enough", NULL);
            break;
    }

    return NO_ERROR_MSG;
}


