#ifndef NTBDAPI_H
#define NTBDAPI_H

#include "BaseClassDAPI.hpp"
#include "NTBDDAPI.hpp"




class NTBDAPI : public BaseClassDAPI
{
    public:
        NTBDAPI(STRING);
        ~NTBDAPI();

        void JustTest();

        ErrorMsg*   searchDevice(vector<NTB_INFO>*  out_pNtbList);
        
        ErrorMsg*   server(string   in_name,
                           UINT64   in_u64PatternSend,
                           UINT64   in_u64PatternRev,
                           UINT32   in_u32Loop);

        ErrorMsg*   client(string   in_name,
                           UINT64   in_u64PatternSend,
                           UINT64   in_u64PatternRev,
                           UINT32   in_u32Loop);
        
        ErrorMsg*   initialWindow();

        ErrorMsg*   testPerformance(UINT64  in_u64PatternSend,
                                    UINT64  in_u64BlockSize,
                                    UINT64  in_u64Loop);

        ErrorMsg*   stress(UINT64  in_u64PatternSend,
                           UINT64  in_u64PatternRev,
                           UINT64  in_u64Loop,
                           bool    in_bShowPerformance,
                           bool    in_bCheckData);

        ErrorMsg*   receiver(UINT64  in_u64PatternRev,
                             UINT64  in_u64Loop);

    private:
        NTBDDAPI*   m_pNTBDriverAPI;
        ErrorMsg*   m_pErrorMsg;
        ERRORCODE   m_eErrorCode;
};

#endif
