/// @file       BaseClassDDAPI.cpp
/// @brief      BaseClassDDAPI class
/// @details    Provide DDAPI base class for all modules
/// @copyright  Copyright 2014 Hon Hai Technology Group. All Rights Reserved.

#include "BaseClassDDAPI.hpp"

/// @fn         BaseClassDDAPI::BaseClassDDAPI(STRING in_szClassName) : BaseClassAPI(in_szClassName)
/// @brief      BaseClassDDAPI constructor
/// @param      in_szClassName is a char string for class name
/// @exception  Nothing
/// @return     Nothing
BaseClassDDAPI::BaseClassDDAPI(STRING in_szClassName) : BaseClassAPI(in_szClassName)
{  

}

/// @fn         BaseClassDDAPI::~BaseClassDDAPI(void)
/// @brief      BaseClassDDAPI destructor
/// @exception  Nothing
/// @return     Nothing
BaseClassDDAPI::~BaseClassDDAPI(void)
{
    // Save the error code
    m_errorCode = NO_ERROR;
}

ErrorMsg*
BaseClassDDAPI::getLEDList(list<string> *out_pLEDList)
{
    return NO_ERROR_MSG;
}

ErrorMsg*
BaseClassDDAPI::getLEDStatus(string in_strLEDName,
                             string *out_strpStatus)
{
    return NO_ERROR_MSG;
}

ErrorMsg*
BaseClassDDAPI::setLEDStatus(string   in_strLEDName,
                             string   in_strStatus)
{
    return NO_ERROR_MSG;
}


