/// @file       ControllerDDAPI.hpp
/// @brief      ControllerDDAPI class
/// @details    Provide low layer diagnostic and utility APIs for Controller module
/// @author     KenHu
/// @copyright  Copyright 2015-2016 Hon Hai Technology Group. All Rights Reserved.

#ifndef CONTROLLER_DDAPI_HPP
#define CONTROLLER_DDAPI_HPP

#include "BaseClassDDAPI.hpp"

#define CONTROLLER_MODULE_NAME  "ctrl"

// LED names
#define CONTROLLER_FAULT_LED    "fault_led"
#define CONTROLLER_ACTIVITY_LED "act_led"

#define SLOT_GPIO_NAME          "SLT_AB_PCH"
#define ACTIVITY_LED_GPIO_NAME  "CTL_ACT_LED_IN"

/// @class      ControllerDDAPI ControllerDDAPI.hpp "ControllerDDAPI.hpp"
/// @brief      Provide low layer diagnostic and utility APIs for Controller module
class ControllerDDAPI : public BaseClassDDAPI
{
    public:
                            ControllerDDAPI();
        virtual             ~ControllerDDAPI(void);

        ErrorMsg*           getLEDList(list<string> *out_pLEDList);
        ErrorMsg*           getLEDStatus(string in_strLEDName,
                                         string *out_strpStatus);
        ErrorMsg*           getSlotID(UINT32 *out_u32pSlotID);

        ErrorMsg*           setLEDStatus(string in_strLEDName,
                                         string in_strStatus);
    protected:
    private:
};

#endif
