#include "ProcessorDDAPI.hpp"


ProcessorDDAPI::ProcessorDDAPI
    (
    STRING className
    ) : BaseClassDDAPI(className)
{

}



ProcessorDDAPI::~ProcessorDDAPI
    (
    )
{

}



CPUInformation::CPUInformation()
{

}



CPUInformation::~CPUInformation()
{

}



ErrorMsg*
ProcessorDDAPI::GetCPUInformation(list<CPUInformation> *CPU_data)
{
    FILE   *pFile;
    CHAR   tokens_1[128], tokens_2[4096];
    string item, data;
    CHAR   line[4096];
    int    i;
    CPUInformation CPU_data_temp;

    //Open /proc/cpuinfo to get CPU data
    pFile = fopen("/proc/cpuinfo", "r");
    if (pFile == NULL)
    {
        return returnErrorMsg((ERRORCODE)(ERROR_PROCESSOR_DDAPI_GET_CPU_INFORMATION | ERROR_PROCESSOR_DDAPI_OPEN_CPU_INFO_FAIL), NULL, NULL);
    }

    //Start get data
    while (fgets(line, 4096, pFile) != NULL)
    {
        //Clean the arrary
        for (i = 0; i < 128; i++)
        {
            tokens_1[i] = 0;
        }

        for (i = 0; i < 4096; i++)
        {
            tokens_2[i] = 0;
        }

        //separate the item of get strings
        sscanf(line, "%[^:]:%[^:]", tokens_1, tokens_2);

        //Remove unused character " " and "\t"
        LTrim(RTrim(tokens_1, '\t'), '\t');
        LTrim(RTrim(tokens_1, ' '), ' ');
        LTrim(RTrim(tokens_2, '\t'), '\t');
        LTrim(RTrim(tokens_2, ' '), ' ');
        RTrim(tokens_2, '\n');

        item = tokens_1;
        data = tokens_2;

        if (item == "processor")
        {
            CPU_data_temp.m_processor_id = atoi(data.c_str());
        }
        else if (item == "vendor_id")
        {
            CPU_data_temp.m_vendor_id = data;
        }
        else if (item == "cpu family")
        {
            CPU_data_temp.m_cpu_family = atoi(data.c_str());
        }
        else if (item == "model name")
        {
            CPU_data_temp.m_model_name = data;
        }
        else if (item == "model")
        {
            CPU_data_temp.m_model = atoi(data.c_str());
        }
        else if (item == "stepping")
        {
            CPU_data_temp.m_stepping = atoi(data.c_str());
        }
        else if (item == "cpu MHz")
        {
            CPU_data_temp.m_cpu_frequency = atof(data.c_str());
        }
        else if (item == "cache size")
        {
            CPU_data_temp.m_cache_size = atoi(data.c_str());
        }
        else if (item == "physical id")
        {
            CPU_data_temp.m_physical_id = atoi(data.c_str());
        }
        else if (item == "siblings")
        {
            CPU_data_temp.m_siblings = atoi(data.c_str());
        }
        else if (item == "core id")
        {
            CPU_data_temp.m_core_id = atoi(data.c_str());
        }
        else if (item == "cpu cores")
        {
            CPU_data_temp.m_cpu_cores = atoi(data.c_str());
        }
        else if (item == "apicid")
        {
            CPU_data_temp.m_apicid = atoi(data.c_str());
        }
        else if (item == "initial apicid")
        {
            CPU_data_temp.m_initial_apicid = atoi(data.c_str());
        }
        else if (item == "fdiv_bug")
        {
            if (data == "yes")
            {
                CPU_data_temp.m_fdiv_bug = TRUE;
            }
            if (data == "no")
            {
                CPU_data_temp.m_fdiv_bug = FALSE;
            }
        }
        else if (item == "hlt_bug")
        {
            if (data == "yes")
            {
                CPU_data_temp.m_hlt_bug = TRUE;
            }
            if (data == "no")
            {
                CPU_data_temp.m_hlt_bug = FALSE;
            }
        }
        else if (item == "f00f_bug")
        {
            if (data == "yes")
            {
                CPU_data_temp.m_f00f_bug = TRUE;
            }
            if (data == "no")
            {
                CPU_data_temp.m_f00f_bug = FALSE;
            }
        }
        else if (item == "coma_bug")
        {
            if (data == "yes")
            {
                CPU_data_temp.m_coma_bug = TRUE;
            }
            if (data == "no")
            {
                CPU_data_temp.m_coma_bug = FALSE;
            }
        }
        else if (item == "fpu_exception")
        {
            if (data == "yes")
            {
                CPU_data_temp.m_fpu_exception = TRUE;
            }
            if (data == "no")
            {
                CPU_data_temp.m_fpu_exception = FALSE;
            }
        }
        else if (item == "fpu")
        {
            if (data == "yes")
            {
                CPU_data_temp.m_fpu = TRUE;
            }
            if (data == "no")
            {
                CPU_data_temp.m_fpu = FALSE;
            }
        }
        else if (item == "cpuid level")
        {
            CPU_data_temp.m_cpuid_level = atoi(data.c_str());
        }
        else if (item == "wp")
        {
            if (data == "yes")
            {
                CPU_data_temp.m_wp = TRUE;
            }
            if (data == "no")
            {
                CPU_data_temp.m_wp = FALSE;
            }
        }
        else if (item == "flags")
        {
            CPU_data_temp.m_flags = data;
        }
        else if (item == "bogomips")
        {
            CPU_data_temp.m_bogomips = atof(data.c_str());
        }
        else if (item == "clflush size")
        {
            CPU_data_temp.m_clflush_size = atoi(data.c_str());
        }
        else if (item == "cache_alignment")
        {
            CPU_data_temp.m_cache_alignment = atoi(data.c_str());
        }
        else if (item == "address sizes")
        {
            int physical_address, virtual_address;
            sscanf(data.c_str(), "%d bits physical, %d bits virtual", &physical_address, &virtual_address);
            CPU_data_temp.m_address_sizes_bits_physical = physical_address;
            CPU_data_temp.m_address_sizes_bits_virtual = virtual_address;
        }
        else if (item == "power management")
        {
            CPU_data_temp.m_power_management = data;
        }
        else if (item.length() == 1)
        {
            CPU_data->push_back(CPU_data_temp);
        }
    }

    fclose(pFile);

//    return returnErrorMsg((ERRORCODE)(ERROR_PROCESSOR_DDAPI_GET_CPU_INFORMATION | ERROR_PROCESSOR_DDAPI_OPEN_CPU_INFO_FAIL), NULL, NULL);
    return NO_ERROR_MSG;
}



//ErrorMsg*
//ProcessorDDAPI::GetCPUInformation
//     (
//     XML_CPU* CPU_data
//     )
//{
//  FILE   *pFile/*, *pXML*/;
/*  CHAR   line[500];
  CHAR   tokens_1[64], tokens_2[512];
  INT32  tokens_2_1, tokens_2_2;
  INT32  i,offset;
  CPU_Information  *cpu_info;

  offset = 0;

  pFile = fopen("/proc/cpuinfo","r");
  if (pFile == NULL)
  {
     //printf("Error opening file\n");
     //return NO_ERROR;
     return returnErrorMsg((ERRORCODE)(ERROR_PROCESSOR_DDAPI_GET_CPU_INFORMATION | ERROR_PROCESSOR_DDAPI_OPEN_CPU_INFO_FAIL), NULL, NULL);
  }

 GetCPUNumber(&(CPU_data->m_cpu_number));
 //printf("CPU:%d\n",CPU_data->m_cpu_number);
 CPU_data->m_cpu_info = new CPU_Information[CPU_data->m_cpu_number];
 cpu_info = CPU_data->m_cpu_info;

// pXML = fopen("cpu_xml.xml","w");
// fprintf(pXML, "<?xml version=\"1.0\"?>\n");
// fprintf(pXML, "<CPU>\n");

  while (fgets(line, 500, pFile) != NULL) {

        //Clean the arrary
        for (i=0 ; i<64 ; i++)
           tokens_1[i] = 0;

        //separate the item of get strings
        sscanf(line, "%[^:]:%[^:]", tokens_1, tokens_2);
        LTrim(RTrim(tokens_2, ' '), ' ');


        if (strncmp(tokens_1, "processor", strlen("processor")) == 0)
        {
           (cpu_info + offset)->m_processor_id = atoi(tokens_2);
//           fprintf(pXML, "<processor>\n<processor_id>%d</processor_id>\n", atoi(tokens_2));
        }
        else if (strncmp(tokens_1, "vendor_id", strlen("vendor_id")) == 0)
        {
           strcpy((cpu_info + offset)->m_vendor_id, RTrim(LTrim(RTrim(tokens_2, ' '), ' '), 10));
//           fprintf(pXML, "<vendor_id>%s</vendor_id>\n", LTrim(RTrim(tokens_2, ' '), ' '));
        }
        else if (strncmp(tokens_1, "cpu family", strlen("cpu family")) == 0)
        {
           (cpu_info + offset)->m_cpu_family = atoi(tokens_2);
//           fprintf(pXML, "<cpu_family>%d</cpu_family>\n", atoi(tokens_2));
        }
        else if (strncmp(tokens_1, "model name", strlen("model name")) == 0)
        {
           strcpy((cpu_info + offset)->m_model_name, RTrim(LTrim(RTrim(tokens_2, ' '), ' '), 10));
//           fprintf(pXML, "<model_name>%s</model_name>\n", LTrim(RTrim(tokens_2, ' '), ' '));
        }
        else if (strncmp(tokens_1, "model", strlen("model")) == 0)
        {
           (cpu_info + offset)->m_model = atoi(tokens_2);
//           fprintf(pXML, "<model>%d</model>\n", atoi(tokens_2));
        }
        else if (strncmp(tokens_1, "stepping", strlen("stepping")) == 0)
        {
           (cpu_info + offset)->m_stepping = atoi(tokens_2);
//           fprintf(pXML, "<stepping>%d</stepping>\n", atoi(tokens_2));
        }
        else if (strncmp(tokens_1, "cpu MHz", strlen("cpu MHz")) == 0)
        {
           (cpu_info + offset)->m_cpu_frequency = atof(tokens_2);
//           fprintf(pXML, "<cpu_frequency>%f</cpu_frequency>\n", atof(tokens_2));
        }
        else if (strncmp(tokens_1, "cache size", strlen("cache size")) == 0)
        {
           (cpu_info + offset)->m_cache_size = atoi(tokens_2);
//           fprintf(pXML, "<cache_size>%d</cache_size>\n", atoi(tokens_2));
        }
        else if (strncmp(tokens_1, "physical id", strlen("physical id")) == 0)
        {
           (cpu_info + offset)->m_physical_id = atoi(tokens_2);
//           fprintf(pXML, "<physical_id>%d</physical_id>\n", atoi(tokens_2));
        }
        else if (strncmp(tokens_1, "siblings", strlen("siblings")) == 0)
        {
           (cpu_info + offset)->m_siblings = atoi(tokens_2);
//           fprintf(pXML, "<siblings>%d</siblings>\n", atoi(tokens_2));
        }
        else if (strncmp(tokens_1, "core id", strlen("core id")) == 0)
        {
           (cpu_info + offset)->m_core_id = atoi(tokens_2);
//           fprintf(pXML, "<core_id>%d</core_id>\n", atoi(tokens_2));
        }
        else if (strncmp(tokens_1, "cpu cores", strlen("cpu cores")) == 0)
        {
           (cpu_info + offset)->m_cpu_cores = atoi(tokens_2);
//           fprintf(pXML, "<cpu_cores>%d</cpu_cores>\n", atoi(tokens_2));
        }
        else if (strncmp(tokens_1, "apicid", strlen("apicid")) == 0)
        {
           (cpu_info + offset)->m_apicid = atoi(tokens_2);
//           fprintf(pXML, "<apicid>%d</apicid>\n", atoi(tokens_2));
        }
        else if (strncmp(tokens_1, "initial apicid", strlen("initial apicid")) == 0)
        {
           (cpu_info + offset)->m_initial_apicid = atoi(tokens_2);
//           fprintf(pXML, "<initial_apicid>%d</initial_apicid>\n", atoi(tokens_2));
        }
        else if (strncmp(tokens_1, "fdiv_bug", strlen("fdiv_bug")) == 0)
        {
           if (strncmp(tokens_2,"yes", strlen("yes")) == 0)
              (cpu_info + offset)->m_fdiv_bug = TRUE;
//              fprintf(pXML, "<fdiv_bug>%d</fdiv_bug>\n", 1); 
           if (strncmp(tokens_2,"no", strlen("no")) == 0)
              (cpu_info + offset)->m_fdiv_bug = FALSE;
//           fprintf(pXML, "<fdiv_bug>%d</fdiv_bug>\n", (my_cpu_info + offset)->fdiv_bug);
//              fprintf(pXML, "<fdiv_bug>%d</fdiv_bug>\n", 0); 
        }
        else if (strncmp(tokens_1, "hlt_bug", strlen("hlt_bug")) == 0)
        {
           if (strncmp(tokens_2,"yes", strlen("yes")) == 0)
              (cpu_info + offset)->m_hlt_bug = TRUE;
//              fprintf(pXML, "<hlt_bug>%d</hlt_bug>\n", 1);
           if (strncmp(tokens_2,"no", strlen("no")) == 0)
              (cpu_info + offset)->m_hlt_bug = FALSE;
//           fprintf(pXML, "<hlt_bug>%d</hlt_bug>\n", (my_cpu_info + offset)->hlt_bug);
//              fprintf(pXML, "<hlt_bug>%d</hlt_bug>\n", 0);
        }
        else if (strncmp(tokens_1, "f00f_bug", strlen("f00f_bug")) == 0)
        {
           if (strncmp(tokens_2,"yes", strlen("yes")) == 0)
              (cpu_info + offset)->m_f00f_bug = TRUE;
//              fprintf(pXML, "<f00f_bug>%d</f00f_bug>\n", 1);
           if (strncmp(tokens_2,"no", strlen("no")) == 0)
              (cpu_info + offset)->m_f00f_bug = FALSE;
//           fprintf(pXML, "<f00f_bug>%d</f00f_bug>\n", (my_cpu_info + offset)->f00f_bug);
//              fprintf(pXML, "<f00f_bug>%d</f00f_bug>\n", 0);
        }
        else if (strncmp(tokens_1, "coma_bug", strlen("coma_bug")) == 0)
        {
           if (strncmp(tokens_2,"yes", strlen("yes")) == 0)
              (cpu_info + offset)->m_coma_bug = TRUE;
//              fprintf(pXML, "<coma_bug>%d</coma_bug>\n", 1);
           if (strncmp(tokens_2,"no", strlen("no")) == 0)
              (cpu_info + offset)->m_coma_bug = FALSE;
//           fprintf(pXML, "<coma_bug>%d</coma_bug>\n", (my_cpu_info + offset)->coma_bug);
//              fprintf(pXML, "<coma_bug>%d</coma_bug>\n", 0);
        }
        else if (strncmp(tokens_1, "fpu_exception", strlen("fpu_exception")) == 0)
        {
           if (strncmp(tokens_2,"yes", strlen("yes")) == 0)
              (cpu_info + offset)->m_fpu_exception = TRUE;
//              fprintf(pXML, "<fpu_exception>%d</fpu_exception>\n", 1);
           if (strncmp(tokens_2,"no", strlen("no")) == 0)
              (cpu_info + offset)->m_fpu_exception = FALSE;
//           fprintf(pXML, "<fpu_exception>%d</fpu_exception>\n", (my_cpu_info + offset)->fpu_exception);
//              fprintf(pXML, "<fpu_exception>%d</fpu_exception>\n", 0);
        }
        else if (strncmp(tokens_1, "fpu", strlen("fpu")) == 0)
        {
           if (strncmp(tokens_2,"yes", strlen("yes")) == 0)
              (cpu_info + offset)->m_fpu = TRUE;
//              fprintf(pXML, "<fpu>%d</fpu>\n", 1);
           if (strncmp(tokens_2,"no", strlen("no")) == 0)
              (cpu_info + offset)->m_fpu = FALSE;
//           fprintf(pXML, "<fpu>%d</fpu>\n", (my_cpu_info + offset)->fpu);
//              fprintf(pXML, "<fpu>%d</fpu>\n", 0);
        }
        else if (strncmp(tokens_1, "cpuid level", strlen("cpuid level")) == 0)
        {
           (cpu_info + offset)->m_cpuid_level = atoi(tokens_2);
//           fprintf(pXML, "<cpuid_level>%d</cpuid_level>\n", atoi(tokens_2));
        }
        else if (strncmp(tokens_1, "wp", strlen("wp")) == 0)
        {
           if (strncmp(tokens_2,"yes", strlen("yes")) == 0)
              (cpu_info + offset)->m_wp = TRUE;
//           fprintf(pXML, "<wp>%d</wp>\n", 1);
            if (strncmp(tokens_2,"no", strlen("no")) == 0)
              (cpu_info + offset)->m_wp = FALSE;
//           fprintf(pXML, "<wp>%d</wp>\n", (my_cpu_info + offset)->wp);
//           fprintf(pXML, "<wp>%d</wp>\n", 0);
        }
        else if (strncmp(tokens_1, "flags", strlen("flags")) == 0)
        {
           strcpy((cpu_info + offset)->m_flags, RTrim(LTrim(RTrim(tokens_2, ' '), ' '), 10));
//           fprintf(pXML, "<flags>%s</flags>\n", LTrim(RTrim(tokens_2, ' '), ' '));
        }
        else if (strncmp(tokens_1, "bogomips", strlen("bogomips")) == 0)
        {
           (cpu_info + offset)->m_bogomips = atof(tokens_2);
//           fprintf(pXML, "<bogomips>%f</bogomips>\n", atof(tokens_2));
        }
        else if (strncmp(tokens_1, "clflush size", strlen("clflush size")) == 0)
        {
           (cpu_info + offset)->m_clflush_size = atoi(tokens_2);
//           fprintf(pXML, "<clflush_size>%d</clflush_size>\n", atoi(tokens_2));
        }
        else if (strncmp(tokens_1, "cache_alignment", strlen("cache_alignment")) == 0)
        {
           (cpu_info + offset)->m_cache_alignment = atoi(tokens_2);
//           fprintf(pXML, "<cache_alignment>%d</cache_alignment>\n", atoi(tokens_2));
        }
        else if (strncmp(tokens_1, "address sizes", strlen("address sizes")) == 0)
        {
           sscanf(tokens_2, "%d bits physical, %d bits virtual", &tokens_2_1, &tokens_2_2);
           (cpu_info + offset)->m_address_sizes_bits_physical = tokens_2_1;
           (cpu_info + offset)->m_address_sizes_bits_virtual  = tokens_2_2;
//           fprintf(pXML, "<address_sizes_bits_physical>%d</address_sizes_bits_physical>\n", tokens_2_1);
//           fprintf(pXML, "<address_sizes_bits_virtual>%d</address_sizes_bits_virtual>\n", tokens_2_2);
        }
        else if (strncmp(tokens_1, "power management", strlen("power management")) == 0)
        {
           strcpy((cpu_info + offset)->m_power_management, RTrim(LTrim(RTrim(tokens_2, ' '), ' '), 10));
//           fprintf(pXML, "<power_management>%s</power_management>\n</processor>\n", LTrim(RTrim(tokens_2, ' '), ' '));
        }
        else if (line[0] == 0x0a)
        {
           offset++;
        }
  }

//   fprintf(pXML, "</CPU>\n");
//   fclose(pXML);
   fclose(pFile);

   return NO_ERROR_MSG;
}*/



CHAR *
ProcessorDDAPI::RTrim
      (
      CHAR *string,
      CHAR junk
      )
{
    CHAR *original = string + strlen(string);

    while(*--original == junk);
       *(original + 1) = '\0';

    return string;
}



CHAR *
ProcessorDDAPI::LTrim
      (
      CHAR *string,
      CHAR junk
      )
{
    CHAR   *original = string;
    CHAR   *p = original;
    INT32  trimmed = 0;

    do
    {
        if (*original != junk || trimmed)
        {
            trimmed = 1;
            *p++ = *original;
        }
    }
    while (*original++ != '\0');

    return string;
}



ErrorMsg*
ProcessorDDAPI::GetCPUNumber
      (
      INT32* CPU_number
      )
{
  FILE *pFile;
  char line[500];
  char tokens_1[64];
  int  i;

  *CPU_number = 0;
  pFile=fopen ("/proc/cpuinfo","r");
  if (pFile==NULL)
  {
     printf("Error opening file\n");
     return returnErrorMsg((ERRORCODE)(ERROR_PROCESSOR_DDAPI_GET_CPU_NUMBER | ERROR_PROCESSOR_DDAPI_OPEN_CPU_INFO_FAIL), NULL, NULL);
  }

  while (fgets(line, 500, pFile) != NULL) {
        for (i=0 ; i<64 ; i++)
           tokens_1[i] = 0;

        sscanf(line, "%[^:]:", tokens_1);

        if (strncmp(tokens_1, "processor", strlen("processor")) == 0)
        {
           //printf("%s  %d",tokens_1, *number);
           *CPU_number = *CPU_number + 1;
        }
  }

  fclose(pFile);
  return NO_ERROR_MSG;
}



ErrorMsg*
ProcessorDDAPI::GetCPUPhysicalNumber(INT32* CPU_number)
{
   FILE *pFile;
   char line[500], tokens_1[64];
   int  i, ID = 0;

   *CPU_number = 0;

   pFile = fopen("/proc/cpuinfo","r");
   if (pFile == NULL)
   {
      printf("Error opening file\n");
      return returnErrorMsg((ERRORCODE)(ERROR_PROCESSOR_DDAPI_GET_CPU_NUMBER | ERROR_PROCESSOR_DDAPI_OPEN_CPU_INFO_FAIL), "Open /proc/cpuinfo fail", NULL);
   }

   while (fgets(line, 500, pFile) != NULL)
   {
      for (i = 0; i < 64 ;i++)
      {
         tokens_1[i] = 0;
      }

      sscanf(line, "%[^:]:", tokens_1);

      if (strncmp(tokens_1, "physical id", strlen("physical id")) == 0)
      {
         //printf("%s  %d",tokens_1, *number);
         sscanf(line, "physical id     : %d", &ID);
         if (ID > *CPU_number)
         {
             *CPU_number = ID;
         }
      }
   }

   *CPU_number = *CPU_number + 1;

   fclose(pFile);
   return NO_ERROR_MSG;
}



ErrorMsg*
ProcessorDDAPI::RegRead(struct pci_device *pci)
{
    struct pci_access *pacc;
    struct pci_dev *dev;
    int err = -1;

    pacc = pci_alloc ();        /* Get the pci_access structure */
    /* Set all options you want -- here we stick with the defaults */
    pci_init (pacc);            /* Initialize the PCI library */
    pci_scan_bus (pacc);        /* We want to get the list of devices */

    for (dev = pacc->devices; dev; dev = dev->next) { /* Iterate over all devices */
        if ((pci->domain == dev->domain) && (pci->bus == dev->bus) &&
            (pci->dev == dev->dev) && (pci->func == dev->func)) {
            err = 0;
            break;
        }
    }

    if (err || (pci->rw_size != 1 && pci->rw_size != 2 && pci->rw_size != 4)) {
        pci_cleanup (pacc);
        if (!err)
            /*printf
                ("[%s +%d]: Not define such R/W size(%d) for read/write PCI device(%02X:%02X.%X)\n",
                 __FILE__, __LINE__, (pci->rw_size & 0xF), pci->bus, pci->dev,
                 pci->func);*/
        return returnErrorMsg((ERRORCODE)(ERROR_PROCESSOR_DDAPI_REG_READ | ERROR_PROCESSOR_DDAPI_REGREAD_FAIL), NULL, NULL);
    }

    switch (pci->rw_size) {
        case RW_BYTE:      /* 1-byte */
            pci->data = pci_read_byte (dev, pci->addr);
            break;
        case RW_WORD:      /* 2-bytes */
            pci->data = pci_read_word (dev, pci->addr);
            break;
        default:           /* 4-bytes */
            pci->data = pci_read_long (dev, pci->addr);
            break;
    }

    pci_cleanup (pacc);         /* Close everything */

    return NO_ERROR_MSG;

}



/*ERRORCODE
ProcessorDDAPI::RegWrite(struct pci_device *pci)
{
    struct pci_access *pacc;
    struct pci_dev *dev;
    int err = -1;

    pacc = pci_alloc ();        // Get the pci_access structure
    // Set all options you want -- here we stick with the defaults
    pci_init (pacc);            // Initialize the PCI library
    pci_scan_bus (pacc);        // We want to get the list of devices

    for (dev = pacc->devices; dev; dev = dev->next) // Iterate over all devices
    {
        if ((pci->domain == dev->domain) && (pci->bus == dev->bus) &&
            (pci->dev == dev->dev) && (pci->func == dev->func)) {
            err = 0;
            break;
        }
    }

    if (err || (pci->rw_size != 1 && pci->rw_size != 2 && pci->rw_size != 4)) {
        pci_cleanup (pacc);
        if (!err)
            printf
                ("[%s +%d]: Not define such R/W size(%d) for read/write PCI device(%02X:%02X.%X)\n",
                 __FILE__, __LINE__, (pci->rw_size & 0xF), pci->bus, pci->dev,
                 pci->func);
        return NO_ERROR;
    }

    switch (pci->rw_size) {
        case RW_BYTE:      // 1-byte
            pci_write_byte (dev, pci->addr, pci->data);
            break;
        case RW_WORD:      // 2-bytes
            pci_write_word (dev, pci->addr, pci->data);
            break;
        default:           // 4-bytes
            pci_write_long (dev, pci->addr, pci->data);
            break;
     }
    return NO_ERROR_MSG;
}*/



ErrorMsg*
ProcessorDDAPI::GetErrorRegistersExecute(INT32 *Test_result)
{
    struct pci_device device;
    //int tmp = 0;

    memset (&device, 0, sizeof (device));
    device.domain = 0x0;
    device.bus = 0x00;
    device.dev = 0x00;
    device.func = 0x00;
    device.addr = 0xc8;  //ERRSTS—Error Status
    device.rw_size = RW_DWORD;

    m_errorCode = RegRead(&device);

    if (m_errorCode != NO_ERROR_MSG)
    {
        //printf ("Fail to call RegRead\n");
        //return NO_ERROR;
        return returnErrorMsg((ERRORCODE)(ERROR_PROCESSOR_DDAPI_GET_ERROR_REGISTERS_EXECUTE | ERROR_PROCESSOR_DDAPI_REGREAD_FAIL), NULL, NULL);
    }
    /*tmp = device.data;
    if (tmp != 0)
    {
        printf ("offset %03X value %08X\n", device.addr, tmp);
    }*/

    *Test_result = device.data;
    return NO_ERROR_MSG;
}



ErrorMsg*
ProcessorDDAPI::ReadCPURegister(string wellKnownName, int CPU_register, int count, list<unsigned long long> *val)
{
    int  ID, CordID, fd, i;
    char file[100], error_msg[256];
    unsigned long long reg_val;
    cpu_set_t set;


    ID = 0;
    CordID = 0;

    //Get CPU well-known ID number
    m_errorCode = GetCPUIDByWellKnowName(wellKnownName, &ID);
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_PROCESSOR_DDAPI_READ_CPU_REGISTER, NULL, m_errorCode);
    }

    //Get system core ID by CPU physical id
    m_errorCode = GetCoreIDByPhycailID(ID, &CordID);
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_PROCESSOR_DDAPI_READ_CPU_REGISTER, NULL, m_errorCode);
    }

    //Set a thread's CPU affinity mask
    CPU_ZERO(&set);
    CPU_SET(CordID, &set);

    if (sched_setaffinity(0, sizeof(cpu_set_t), &set) != 0)
    {
        return returnErrorMsg(ERROR_PROCESSOR_DDAPI_READ_CPU_REGISTER, "sched_setaffinity fail", NULL);
    }

    //Open CPU MSR node to read register
    sprintf(file, "/dev/cpu/%d/msr", CordID);
    fd = open(file, O_RDONLY);
    if (fd < 0)
    {
        sprintf(file, "Open /dev/cpu/%d/msr CPU MSR node fail", CordID);
        return returnErrorMsg(ERROR_PROCESSOR_DDAPI_READ_CPU_REGISTER, file, NULL);
    }

    for (i = 0; i < count; i++)
    {
        if (lseek(fd, CPU_register + i, SEEK_SET) == -1)
        {
            close(fd);
            return returnErrorMsg(ERROR_PROCESSOR_DDAPI_READ_CPU_REGISTER, "Move file pointer to register fail", NULL);
        }

        if (read(fd, &reg_val, 8) != 8)
        {
            close(fd);
            sprintf(error_msg ,"Read register 0x%x fail", CPU_register + i);
            return returnErrorMsg(ERROR_PROCESSOR_DDAPI_READ_CPU_REGISTER, error_msg, NULL);
        }
        val->push_back(reg_val);
    }

    close(fd);

    return NO_ERROR_MSG;
}



ErrorMsg*
ProcessorDDAPI::WriteCPURegister(string wellKnownName, int CPU_register, unsigned long long Data)
{
    int  ID, CordID, fd, i;
    char file[100], error_msg[256];
    cpu_set_t set;


    ID = 0;
    CordID = 0;

    //Get CPU well-known ID number
    m_errorCode = GetCPUIDByWellKnowName(wellKnownName, &ID);
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_PROCESSOR_DDAPI_WRITE_CPU_REGISTER, NULL, m_errorCode);
    }

    //Get system core ID by CPU physical id
    m_errorCode = GetCoreIDByPhycailID(ID, &CordID);
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_PROCESSOR_DDAPI_WRITE_CPU_REGISTER, NULL, m_errorCode);
    }

    //Set a thread's CPU affinity mask
    CPU_ZERO(&set);
    CPU_SET(CordID, &set);

    if (sched_setaffinity(0, sizeof(cpu_set_t), &set) != 0)
    {
        return returnErrorMsg(ERROR_PROCESSOR_DDAPI_WRITE_CPU_REGISTER, "sched_setaffinity fail", NULL);
    }

    //Open CPU MSR node to read register
    sprintf(file, "/dev/cpu/%d/msr", CordID);
    fd = open(file, O_WRONLY);
    if (fd < 0)
    {
        sprintf(file, "Open /dev/cpu/%d/msr CPU MSR node fail", CordID);
        return returnErrorMsg(ERROR_PROCESSOR_DDAPI_WRITE_CPU_REGISTER, file, NULL);
    }

    //Movee point to register address
    if (lseek(fd, CPU_register, SEEK_SET) == -1)
    {
        close(fd);
        return returnErrorMsg(ERROR_PROCESSOR_DDAPI_WRITE_CPU_REGISTER, "Move file pointer to register fail", NULL);
    }

    //Write data to CPU
    if (write(fd, &Data, 8) != 8)
    {
        close(fd);
        sprintf(error_msg ,"Write register 0x%x fail", CPU_register + i);
         return returnErrorMsg(ERROR_PROCESSOR_DDAPI_WRITE_CPU_REGISTER, error_msg, NULL);
    }

    close(fd);

    return NO_ERROR_MSG;
}



ErrorMsg*
ProcessorDDAPI::GetCPUIDByWellKnowName(string wellKnownName, int *ID)
{
    int    i, cpu_number;
    char   cpuID[15];

    //Get CPU number
    GetCPUNumber(&cpu_number);

    for (i = 0; i < cpu_number; i++)
    {
        sprintf(cpuID, "processor%d", i);
        if (wellKnownName == cpuID)
        {
            *ID = i;
            break;
        }
    }

    if (i == cpu_number)
    {
        return returnErrorMsg(ERROR_PROCESSOR_DAPI_GET_INFORMATIOM, "CPU ID out of range", NULL);
    }

    return NO_ERROR_MSG;
}



ErrorMsg*
ProcessorDDAPI::GetCoreIDByPhycailID(int ID, int *CordID)
{
    list<CPUInformation>           CPU_data;
    list<CPUInformation>::iterator it;


    //Get CPU information
    m_errorCode = GetCPUInformation(&CPU_data);
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_PROCESSOR_DAPI_GET_ERROR_REGISTER, NULL, m_errorCode);
    }

    //Search CPU physical id
    for (it = CPU_data.begin(); it != CPU_data.end(); it++)
    {
        if (ID == (*it).m_physical_id)
        {
            *CordID = (*it).m_processor_id;
            break;
        }
    }

    if (it == CPU_data.end())
    {
        return returnErrorMsg(ERROR_PROCESSOR_DAPI_GET_INFORMATIOM, "CPU ID not founded", NULL);
    }

    return NO_ERROR_MSG;
}



ErrorMsg*
ProcessorDDAPI::getTemperatureDataByID(string well_know_name, CPU_TEMPERATURE_OPERATION_ID ID, string *result)
{
    I2CTemperature *i2c_temperature = NULL; //Temporarily use I2C temperature base class
    CPUInformation device;


    m_errorCode = NO_ERROR_MSG;

    //Get CPU device object by name
    m_errorCode = get_device_by_well_known_name(well_know_name, &device);


    //Base on different model to create the essential object
    if (device.m_cpu_family == 6 && device.m_model == 86) // Intel BroadwellDE
    {
        i2c_temperature = new BroadwellDE("Broadwell-DE temp driver");
    }
    else if (device.m_cpu_family == 6 && device.m_model == 79) // Intel BroadwellDE
    {
        i2c_temperature = new BroadwellDE("Broadwell-DE temp driver");
    }
    else
    {
        return returnErrorMsg(ERROR_I2C_DAPI_MUX_TEST, "Not support CPU temperature", m_errorCode);
    }


    switch (ID)
    {
        case CPU_CURRENT_TEMPERATURE:  //Get sensor currrnt temperature
            m_errorCode = i2c_temperature->GetCurrntTemperature(well_know_name, result);
            break;
        case CPU_THRESHOLD_HIGH:  //Get temperature threshold high
            m_errorCode = i2c_temperature->GetThresholdHigh(well_know_name, result);
            break;
        case CPU_THRESHOLD_LOW:  //Get temperature threshold low
            m_errorCode = i2c_temperature->GetThresholdLow(well_know_name, result);
            break;
        default:
            break;
    }

    delete i2c_temperature;

    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_MUX_TEST, NULL, m_errorCode);
    }

    return NO_ERROR_MSG;
}



ErrorMsg*
ProcessorDDAPI::setTemperatureDataByID(string well_know_name, CPU_TEMPERATURE_OPERATION_ID ID, string data)
{
    I2CTemperature *i2c_temperature = NULL; //Temporarily use I2C temperature base class
    CPUInformation device;


    m_errorCode = NO_ERROR_MSG;

    //Get CPU device object by name
    m_errorCode = get_device_by_well_known_name(well_know_name, &device);

    //Base on different model to create the essential object
    if (device.m_cpu_family == 6 && device.m_model == 86)
    {
        i2c_temperature = new BroadwellDE("Broadwell-DE temp driver");
    }
    else
    {
        return returnErrorMsg(ERROR_I2C_DAPI_MUX_TEST, "Not support CPU temperature", m_errorCode);
    }


    switch (ID)
    {
        case CPU_THRESHOLD_HIGH:  //Set temperature threshold high
            m_errorCode = i2c_temperature->SetThresholdHigh(well_know_name, data);
            break;
        case CPU_THRESHOLD_LOW:  //Set temperature threshold low
            m_errorCode = i2c_temperature->SetThresholdLow(well_know_name, data);
            break;
        default:
            break;
    }

    delete i2c_temperature;

    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_MUX_TEST, NULL, m_errorCode);
    }

    return NO_ERROR_MSG;
}



ErrorMsg*
ProcessorDDAPI::get_device_by_well_known_name(string wellKnownName, CPUInformation *device)
{
    int ID = 0;
    list<CPUInformation>           CPU_data;
    list<CPUInformation>::iterator it;

    //Get CPU well-known ID number
    m_errorCode = GetCPUIDByWellKnowName(wellKnownName, &ID);
    if (m_errorCode != NO_ERROR_MSG)
    {
        return m_errorCode;
    }

    //Get CPU information
    m_errorCode = GetCPUInformation(&CPU_data);
    if (m_errorCode != NO_ERROR_MSG)
    {
        return m_errorCode;
    }

    //Search CPU physical id
    for (it = CPU_data.begin(); it != CPU_data.end(); it++)
    {
        if (ID == (*it).m_physical_id)
        {
            *device = *it;
            return NO_ERROR_MSG;
        }
    }

    if (it == CPU_data.end())
    {
        return returnErrorMsg(ERROR_PROCESSOR_DAPI_GET_INFORMATIOM, "CPU ID not founded", NULL);
    }
}