#ifndef CHELSIS_T62100_H
#define CHELSIS_T62100_H

#include "EthernetBaseClass.hpp"
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/mman.h>


class CHELSIS_T62100 : public EthernetBaseClass
{
    public:
                  CHELSIS_T62100(STRING);
                  ~CHELSIS_T62100();
        ErrorMsg* Set_external_loopback();
        ErrorMsg* Remove_external_loopback();
        ErrorMsg* Get_self_test_result(struct ethtool_test *test, TestType index, INT32 *test_result);
        ErrorMsg* SetupSpeed(string ethernet_name, INT32 speed);
        ErrorMsg* GetMAC(string ethernet_name, string *mac_address);
        ErrorMsg* SetMAC(string ethernet_name, string *mac_address);
        ErrorMsg* GetEEPROM(string ethernet_name, INT32 StartAddress, INT32 Length, INT32 *data);
        ErrorMsg* SetEEPROM(string ethernet_name, INT32 StartAddress, INT32 *data, INT32 Length);
        ErrorMsg* Program(string ethernet_name, string filePath);
        ErrorMsg* ReadSFP(string ethernet_name, INT32 DeviceAddress, INT32 StartAddress, INT32 Length, INT32 *data);
        ErrorMsg* WriteSFP(string ethernet_name, INT32 DeviceAddress, INT32 StartAddress, INT32 data);
        ErrorMsg* getLEDName(string ethernet_name, list<string> *LED);
        ErrorMsg* setLEDStatus(string ethernet_name, string in_strLEDName, string in_strStatus);
        ErrorMsg* getLEDStatus(string ethernet_name, string in_strLEDName, string *out_strpStatus);
             int  read_PHY_reg(int reg, int page);
             int  write_PHY_reg(int reg, int page , int data);

    protected:

    private:
        unsigned int *MDIO_point;
        ErrorMsg     *m_errorCode;
};

#endif

