	#ifndef GPIO_DDAPI_H
#define GPIO_DDAPI_H

#include "BaseClassDDAPI.hpp"
//#include "GPIODevice.hpp"

//#include "GPIOSwitch.hpp"
//#include "GPIOBus.hpp"
#include <sys/stat.h>

#include <dirent.h>
#include <unistd.h>

#include <fcntl.h>
#include <sys/time.h>
#include "CommonFunctions.hpp"
//#include <algorithm>
#include <list>
//#include "SCSICommand.hpp"
//#include <errno.h>
//#include <sys/ioctl.h>

#include "GPIOGeneric.hpp"
#include "GPIO_FPGADriver.hpp"
#include "GPIO_PCHDriver.hpp"


using namespace std;


#define MAX_NUMBER_OF_GPIO_DRIVERS 10

/*
#define MAX_GPIO_DEVICE_NO       256

#define GPIO_ID_UNDEFINED        0xFFFF

#define GPIO_SYSTEM_BUS_PATH     "/sys/bus/GPIO/devices/"
#define GPIO_SYSTEM_BLPCK_PATH   "/sys/block/"

#define MEGA_BYTES_SIZE         (1024*1024)
#define GPIO_BLOCK_SIZE          (512)
#define UINT_MAX                (2147483647 * 2U + 1U)
*/
#ifdef DEBUG
	#define PROFILE_PATH_NAME   "GPIO_profile.ini"
#else
	#define PROFILE_PATH_NAME   "/etc/lemur/GPIO_profile.ini"
#endif


typedef enum
{
    GPIO_FPGA_DRIVER=0,
    GPIO_PCH_DRIVER=1,

    GPIO_MAX_TYPE_NUMBER,
}GPIO_TYPE;



class GPIODDAPI : public BaseClassDDAPI
{
public:
                     GPIODDAPI(STRING className);
                    ~GPIODDAPI();

                     ErrorMsg*  getGPIOList(list<string> *pGPIOList);
                     ErrorMsg*  getLogicalIdByName(STRING WellKnownName, UINT32 *LogicalID);

                     ErrorMsg*   GetWellKnownNameByIndex(INT32 index, CHAR* gpioName, INT32 stringLength);
                     ErrorMsg*   readBit(string gpioName, BOOL* readValue);
                     //ErrorMsg*   resetBit(string  gpioName);
                     ErrorMsg*   writeBit(string  gpioName, BOOL Status);




protected:
                     //ErrorMsg* m_errorCode;

private:
                     GPIOGeneric*      m_GPIODriverList[MAX_NUMBER_OF_GPIO_DRIVERS];

};


#endif

