#ifndef I2CDevice_H
#define I2CDevice_H

#include "I2CBus.hpp"

#define REGISTER_NUMBER 512



class I2CDevice
{
public:
                        I2CDevice(string name, int bus, int device_address, I2C_DEVICE_TYPE device_type, string device_vender, string device_model);
            virtual    ~I2CDevice();
            int         get_Bus();
            int         get_Address();
            char     *  get_Name();
            ErrorMsg *  set_Master_bus(I2CBus *master_bus);
            I2CBus   *  get_Master_bus();
            ErrorMsg *  Read(struct pci_device *pci);
            ErrorMsg *  Write(struct pci_device *pci);
    virtual int         IsSwitch();
            ErrorMsg *  set_Register_protocol(int index, I2C_DEVICE_PROTOCOL protocol);
            int         get_Register_protocol(int index);
            I2C_DEVICE_TYPE  get_type();
            string      get_vender();
            string      get_model();


protected:

private:
            ErrorMsg             *m_errorCode;
            int                  m_bus;            //Logical bus
            int                  m_device_address;
            string               m_device_name;
            I2CBus               *m_master_bus;
            I2C_DEVICE_PROTOCOL  m_register_protocol[REGISTER_NUMBER];
            I2C_DEVICE_TYPE      m_device_type;
            string               m_device_vender;
            string               m_device_model;
};

#endif

