/// @file       ECCInformation.hpp
/// @brief      ECCInformation class
/// @details    Provide class of ECC information for memory module
/// @author     KenHu
/// @copyright  Copyright 2014 Hon Hai Technology Group. All Rights Reserved.

#ifndef ECC_INFORMATION_HPP
#define ECC_INFORMATION_HPP

#include <string>

/// @class      ECCInformation ECCInformation.hpp "ECCInformation.hpp"
/// @brief      Provide ECC information for each rank
/// @param      m_s32ControllerID is a 32 bits value for memory controller ID
/// @param      m_s32ChannelID is a 32 bits value for channel ID
/// @param      m_s32SlotID is a 32 bits value for slot ID
/// @param      m_s32RankID is a 32 bits value for rank ID of DIMM
/// @param      m_s32ErrorCount is a 32 bits value for error count
class ECCInformation
{
    public:
                            ECCInformation() 
                            {
                                m_s32ControllerID = 0;
                                m_s32ChannelID = 0;
                                m_s32SlotID = 0;
                                m_s32RankID = 0;
                                m_s32ErrorCount = 0;
                            };
        virtual             ~ECCInformation() {};

        string              m_strDIMMName;
        INT32               m_s32ControllerID;
        INT32               m_s32ChannelID;
        INT32               m_s32SlotID;
        INT32               m_s32RankID;
        UINT32              m_s32ErrorCount;
    protected:
    private:
};

#endif
