/*
 * GPIOGeneric.hpp
 *
 *  Created on: Dec 2, 2015
 *      Author: ianfang
 */

#ifndef TEMPTERATURE_GENERIC_HPP
#define TEMPTERATURE_GENERIC_HPP
#include "BaseClassDDAPI.hpp"
#include "CommonFunctions.hpp"
#include <list>

#include "SASDDAPI.hpp"
#include "I2CDDAPI.hpp"
#include "PSUDDAPI.hpp"
#include "ProcessorDDAPI.hpp"

using namespace std;

typedef enum
{
    TEMPERATURE_PCM_DRIVER=0,
    TEMPERATURE_SATA_DRIVER,
    TEMPERATURE_SAS_DRIVER,
    TEMPERATURE_PSU_DRIVER,
    TEMPERATURE_EXPANDER_DRIVER,
    TEMPERATURE_I2C_DRIVER,
	TEMPERATURE_CPU_DRIVER,




    TEMPERATURE_TYPE_MAX_NUMBER,
}TEMPERATURE_TYPE;

typedef enum
{
    TEMPERATURE_DATA_ALL_INFO=0,
    TEMPERATURE_DATA_CURRENT_TEMPERATURE,
    TEMPERATURE_DATA_THRESHOLD_HIGH0,
    TEMPERATURE_DATA_THRESHOLD_LOW0,
    TEMPERATURE_DATA_THRESHOLD_HIGH1,
    TEMPERATURE_DATA_THRESHOLD_LOW1,

    TEMPERATURE_DATA_ELEMENT_MAX_NUMBER,
}TEMPERATURE_DATA_ELEMENT;


#define FPGA_DATA_ELEMENT_NAME_LENGTH   20


class TemperatureGeneric : public BaseClassDDAPI
{
    public:
            TemperatureGeneric(STRING className);
            ~TemperatureGeneric();

            virtual ErrorMsg*  getTemperatureNameList(list<string> *pTemperatureList);

            virtual ErrorMsg*  getDataByName(STRING WellKnownName,
                                             TEMPERATURE_DATA_ELEMENT TemperatureDataElement,
                                             list<string> *returnDataInfo);
            virtual ErrorMsg*  setDataByName(STRING WellKnownName,
                                             TEMPERATURE_DATA_ELEMENT TemperatureDataElement,
											 string	SetValue);

            //virtual ErrorMsg*   readINIFile(CHAR *Line);
            /*
            virtual ErrorMsg*   getCurrentTemperatureList(STRING WellKnownName,
                                                          TEMPERATURE_DATA_ELEMENT TemperatureDataElement,
                                                          list<string> *returnDataInfo);
            virtual ErrorMsg*   getThresholdHighList(list<string> *pTemperatureList);
            virtual ErrorMsg*   getThresholdLowList(list<string> *pTemperatureList);
            */
/*
            virtual ErrorMsg*   readBit(string gpioName, BOOL*  readValue);
            virtual ErrorMsg*   isMyTemperature(string    gpioName);
            virtual ErrorMsg*   setBit(string  gpioName, BOOL Status);
           */


//        virtual ERRORCODE AddEntry(STRING gpioName,
//                                   PHYSICAL_ADDRESS_T gpioAddress,
//                                   INT32 gpioBit,
//                                   BOOL gpioControl,
//                                   UINT32 misc
//                                   );
//        virtual ERRORCODE AddEntry(STRING gpioName,
//                                   UINT32 gpioIndex,
//                                   UINT32 bWritable
//                                   );
//        virtual ERRORCODE GetWellKnownNameByIndex(INT32 index, CHAR* gpioName, INT32 stringLength);
//        virtual ERRORCODE IsMyTemperature(STRING gpioName);
//        virtual ERRORCODE ReadBit(STRING gpioName, BOOL* readValue);
//        virtual ERRORCODE ResetBit(STRING gpioName);
//        virtual ERRORCODE SetBit(STRING gpioName);

    protected:

    private:



};





#endif /* TEMPTERATURE_GENERIC_HPP_ */
