#ifndef Temperature_I2C_H
#define Temperature_I2C_H

#include "TemperatureGeneric.hpp"
#include <fcntl.h>
#include <unistd.h>
#include <sys/mman.h>



class Temperature_I2C : public TemperatureGeneric
{
    public:
                       Temperature_I2C(STRING  ClassName);
                       ~Temperature_I2C();

                       ErrorMsg*  getTemperatureNameList(list<string> *pTemperatureList);

                       ErrorMsg*  getDataByName(STRING WellKnownName,
                    		   	   	   	   	    TEMPERATURE_DATA_ELEMENT TemperatureDataElement,
												list<string> *returnDataInfo);
                       ErrorMsg*  setDataByName(STRING WellKnownName,
                    		   	   	   	   	    TEMPERATURE_DATA_ELEMENT TemperatureDataElement,
												string	SetValue);
/*
             ErrorMsg* Setup_resource_path(string path, int id_index);

     virtual string Get_name();
     virtual ErrorMsg* Get_current_temperature(float *temp);
     virtual ErrorMsg* Get_threshold_hight(float *temp);
     virtual ErrorMsg* Get_threshold_low(float *temp);
     //virtual ErrorMsg* Set_name(string name);
     virtual ErrorMsg* Set_threshold_hight(float temp);
     virtual ErrorMsg* Set_threshold_low(float temp);
*/
    protected:

    private:
                       I2CDDAPI	*m_I2CDdapi;

                       ErrorMsg*   getCurrentTemperatureList(STRING WellKnownName,
                                                             list<string> *returnDataInfo);

                       ErrorMsg*   getThresholdHigh0List(STRING WellKnownName, list<string> *pTemperatureList);
                       ErrorMsg*   getThresholdLow0List(STRING WellKnownName, list<string> *pTemperatureList);
                       ErrorMsg*   getThresholdHigh1List(STRING WellKnownName, list<string> *pTemperatureList);
                       ErrorMsg*   getThresholdLow1List(STRING WellKnownName, list<string> *pTemperatureList);

                       ErrorMsg*   setThresholdHigh0List(STRING WellKnownName, string SetValue);
                       ErrorMsg*   setThresholdLow0List(STRING WellKnownName, string SetValue);
                       ErrorMsg*   setThresholdHigh1List(STRING WellKnownName, string SetValue);
                       ErrorMsg*   setThresholdLow1List(STRING WellKnownName, string SetValue);
            //string resource_path;
            //int    index;
};

#endif
