#ifndef TPMStructureDefinitions_H
#define TPMStructureDefinitions_H 

#define TPM_ST_NO_SESSIONS  0x8001
#define TPM_RC_SUCCESS      0x0

enum TPM_CAP 
{
    TPM_CAP_FIRST   = 0x00000000,
    TPM_CAP_ALGS    = 0x00000000,
    TPM_CAP_HANDLES,
    TPM_CAP_COMMANDS,
    TPM_CAP_PP_COMMANDS,
    TPM_CAP_AUDIT_COMMANDS,
    TPM_CAP_PCRS,
    TPM_CAP_TPM_PROPERTIES,
    TPM_CAP_PCR_PROPERTIES,
    TPM_CAP_ECC_CURVES          = 0x00000008,
    TPM_CAP_LAST                = 0x00000008,
    TPM_CAP_VENDOR_PROPERTY     = 0x00000100,
};


#define PT_GROUP    0x00000100
#define PT_FIXED    PT_GROUP * 1
#define PT_VAR      PT_GROUP * 2

enum TPM_PT 
{
    //fixed properties 
    TPM_PT_FAMILY_INDICATOR = PT_FIXED + 0, 
    TPM_PT_LEVEL,
    TPM_PT_REVISION,
    TPM_PT_DAY_OF_YEAR,
    TPM_PT_YEAR,
    TPM_PT_MANUFACTURER,
    TPM_PT_VENDOR_STRING_1,
    TPM_PT_VENDOR_STRING_2,
    TPM_PT_VENDOR_STRING_3,
    TPM_PT_VENDOR_STRING_4,
    TPM_PT_VENDOR_TPM_TYPE,
    TPM_PT_FIRMWARE_VERSION_1,
    TPM_PT_FIRMWARE_VERSION_2,

    //variable properties 
    TPM_PT_PERMANENT = PT_VAR + 0,
    TPM_PT_STARTUP_CLEAR,
};


enum TPM_CC 
{
    TPM_CC_SELF_TEST = 0x00000143,
    TPM_CC_GET_CAPABILITY = 0x0000017A,
};

#endif
